angular.module('noc').component('costAnnualSavingsComponent', {
    bindings: {
        savingsData: '='
    },
    templateUrl: 'assets/templates/components/cost/cost-annual-savings-component.html',
    controller: function ($filter) {
        this.$onInit = () => {
            if (this.savingsData) {
                if (this.savingsData.isVsaAvailable) {
                    this.totalSaving = 0;
                } else {
                    this.totalSaving = _.reduce(this.savingsData.savings, (total, val) => total + val.monthlySaving.amount, 0);
                }
                this.isOntapSaveCost = (this.totalSaving > 0);

                this.savingsDataForChart = _.map(this.savingsData.savings, (categoryData) => {
                    return ({name: categoryData.name, y: categoryData.monthlySaving.amount});
                });
                this.formattedTotalAmount = `$ ${$filter('number')(this.totalSaving || 0, 0)}`;
            }
        };

        this.toggleSavingInformation = (sectionName) => {
            if (this.currentOpenSection === sectionName) {
                this.currentOpenSection = '';
            } else {
                this.currentOpenSection = sectionName;
            }
        };
    }
});
