angular.module('noc').component('costComponent', {
    bindings: {
        costAndSavingsResponse: '='
    },
    templateUrl: 'assets/templates/components/cost/cost-component.html',
    controller: function (nocDialog) {
        this.$onInit = () => {
            // Data from AWS is not available for a newly created working environment (for ~24 hours) - API returns "0"
            // If the total for first month is 0 and hours since creation is less than 30, then we know this is a new VSA
            const amountFirstMonth = _.get(this.costAndSavingsResponse, 'costResponse.costByTime[0].total.amount');
            const hoursSinceWeCreation = moment().diff(moment(_.get(this.costAndSavingsResponse, 'workingEnvironment.ontapClusterProperties.creationTime')), 'hours');
            this.isNewVsa = (!amountFirstMonth && hoursSinceWeCreation < 30);
        };
        this.calculationClicked = () => {
            nocDialog.confirm('', 'assets/templates/dialogs/cost-calculation-method-dialog.html',
                {
                    fromTop: '19%',
                    width: 800
                });
        };
    }
});
