angular.module('noc.components').directive('nocIfServiceSupported', ($rootScope, $log, nocRoutingResolverService) => {
    'use strict';

    return {
        restrict: 'A',
        priority: 499,
        link: function link(scope, element, attrs) {
            const serviceName = attrs.nocIfServiceSupported;
            const serviceSupported = _.get($rootScope.supportServices, serviceName + 'Enabled');
            if (!serviceSupported) {
                $log.debug('Hiding menu item "' + element.text() + '" since service "' + serviceName + '" is not supported');

                element.addClass('service-not-supported');
            }

            if (serviceName === 'volumeView') {
                nocRoutingResolverService.isVolumeViewAllowed($rootScope)
                    .catch(() => {
                        element.addClass('service-not-supported');
                    });
            }
        }
    };
});
