(function(){
    "use strict";
    // Gives an illusion that the scrollbar is detached from the document flow by changing the padding and margin of the container
    // so that the container content doesn't change its position when the scrollbar appears.
    angular.module('noc.components').directive('nocDetachedScrollbar', function(){

        return{
            restrict: 'A',
            link: function (scope, element, attrs) {
                var PADDING_RIGHT = 'padding-right', MARGIN_RIGHT = 'margin-right';
                var scrollbarThreshold = attrs['nocDetachedScrollbar'];

                var defaultPaddingRight = element.css(PADDING_RIGHT),
                    defaultMarginRight = element.css(MARGIN_RIGHT);


                scope.$watchGroup(['expanded','alertMessages.errors.length'], function(values) {

                    var expanded = values[0],
                        messagesCount = values[1];

                    if (expanded && messagesCount > scrollbarThreshold) {
                        element.css(PADDING_RIGHT, 13);
                        element.css(MARGIN_RIGHT, -30);
                    } else {
                        element.css(PADDING_RIGHT, defaultPaddingRight);
                        element.css(MARGIN_RIGHT, defaultMarginRight);
                    }
                });

            }
        };
    });
})();
