//This directive is used to replace a plain text url inside an element with an <a> tag link.
//It supports a single url per element
//The url is recognized by "http" or "https" beginning
//The directive can be provided with "textToRemove" and "textForLink" (optional)

(() => {
    'use strict';
    angular.module('noc').directive('parseMessageWithUrl', () => {
        const urlPattern = /https?:\/\/([-a-z0-9@:%_+.~#?&/=]*)/gi;

        return {
            restrict: 'A',
            require: 'ngModel',
            scope: {
                ngModel: '=ngModel',
                textToRemove: '@',
                textForLink: '@'
            },
            link: (scope, element) => {
                scope.$watch('ngModel', (value) => {
                    if (!scope.textForLink) {
                        scope.textForLink = value.match(urlPattern);
                    }
                    const html = _(value)
                        .replace(urlPattern, `<a href="$&" target="_blank" title="$&">${scope.textForLink}</a>`)
                        .replace(scope.textToRemove, '');
                    element.html(html);
                });
            }
        };
    });
})();
