angular.module('noc.components').directive('nocPasswordVerify', ($timeout) => {
    'use strict';

    return {
        require: '?ngModel',
        scope: {
            nocPasswordVerify: '='
        },
        link: function link(scope, element, attributes, ctrl) {
            let combined = {};

            scope.$watch(() => {
                if (scope.nocPasswordVerify !== combined.password || ctrl.$viewValue !== combined.retype) {
                    combined = {password: scope.nocPasswordVerify, retype: ctrl.$viewValue};
                }

                return combined;
            }, (value) => {
                if (_.isEmpty(value.password) || _.isUndefined(value.password) || _.isEmpty(value.retype) || _.isEmpty(value.retype)) {
                    ctrl.$setValidity('passwordVerify', true);
                } else if (value.password !== value.retype) {
                    ctrl.$setValidity('passwordVerify', false);
                } else {
                    ctrl.$setValidity('passwordVerify', true);
                }

                $timeout(_.noop, 0, true);
            });
        }
    };
});
