angular.module('noc.components').directive('nocPermission', (nocCurrentUserService, nocSelectedWorkspaceOrTenantService) => {
    'use strict';

    /*
     The permissions can be a single permission as a string, or a list of strings in an array
     A permission must be of the format <resource_name>:<action>
     If more than one permission is required, each permission must be listed. It is not possible to use * instead of <action>
     */
    return {
        restrict: 'A',
        scope: {
            nocPermission: '='
        },
        priority: 499,
        link: function link(scope, element) {
            function permissionFunction() {
                const isPermitted = nocCurrentUserService.isAllowed(scope.nocPermission, nocSelectedWorkspaceOrTenantService.getSelectedWorkspace());
                if (!isPermitted) {
                    element.addClass('no-permission');
                }
            }

            permissionFunction();
        }
    };
});
