(() => {
    'use strict';

    angular.module('noc').directive('nocRadio', () => {
        let labelElement;

        return {
            restrict: 'A',
            require: 'ngModel',
            scope: false,
            link: (scope, element, attrs, ngModel) => {
                labelElement = $('<label class="radio-label">');
                element.wrap(labelElement);
                element.parent().append(attrs.text);

                const runit = () => {
                    if (ngModel.$modelValue === attrs.value) {
                        element.parent().addClass('radio-label-selected');
                    } else {
                        element.parent().removeClass('radio-label-selected');
                    }
                };

                attrs.$observe('value', runit);
                scope.$watch(() => ngModel.$modelValue, runit);

                attrs.$observe('disabled', (value) => {
                    if (value) {
                        element.parent().addClass('radio-label-disabled');
                    } else {
                        element.parent().removeClass('radio-label-disabled');
                    }
                });

                element.focus(() => {
                    element.parent().addClass('radio-label-focused');
                });
                element.blur(() => {
                    element.parent().removeClass('radio-label-focused');
                });
            }
        };
    });
})();
