(() => {
    'use strict';
    angular.module('noc.components').directive('nocRoundedIcon', (nocIconMap) => {

        var svgs = {};
        var loadReplaceSvg = function loadReplaceSvg(el, attrs, replace) {
            import(`images/icons/${attrs.name}.svg`).then((module) => {
                const svgUrl = module.default;
                if (replace) {
                    el.children()[0].remove();
                }
                el.append(svgUrl);
                el.addClass([attrs.name + '-icon']);
            });
        };

        return {
            restrict: 'E',
            template: '<div class="rounded-icon" ng-class="name + \'-icon\'"><ng-include src="src"></ng-include></div>',
            replace: true,
            link: function link(scope, el, attrs) {
                scope.name = attrs.name;
                scope.src = nocIconMap[attrs.name];

                var hasIcon;

                attrs.$observe('name', function () {
                    if (!hasIcon) {
                        loadReplaceSvg(el, attrs, false);
                        hasIcon = true;
                    } else {
                        loadReplaceSvg(el, attrs, true);
                    }
                });
            }
        };
    });
})();
