((angular) => {
    'use strict';
    angular.module('noc.components').directive('nocSearchWidget', () => {
        return {
            restrict: 'E',
            templateUrl: 'assets/templates/components/search-widget.html',
            require: 'ngModel',
            scope: {
                searchString: "=ngModel",
                ngChange: "=ngChange"
            },
            replace: false,
            link: function (scope, elem, attrs, modelCtrl) {
                var isCloseable = 'closeable' in attrs;
                scope.enableSearchFields = !isCloseable;

                var input = elem.find('input');
                const onBlur = () => {
                    if (!modelCtrl.$viewValue) {
                        scope.enableSearchFields = false;
                    }
                };

                function clearSearchString(){
                    scope.searchString = '';
                    if(_.isFunction(scope.ngChange)) scope.ngChange();
                }

                scope.clear = function () {
                    clearSearchString();
                    input.focus();
                };

                scope.close = function(){
                    clearSearchString();
                    if (isCloseable) {
                        scope.enableSearchFields = false;
                    }
                };

                scope.$on('$destroy', function() {
                    scope.clear();
                    modelCtrl.$setViewValue();
                });

                attrs.$observe('placeholder', function (value) {
                    input.prop('placeholder', value);
                });

                if (isCloseable) {
                    input.bind('blur', onBlur);
                }
            }
        };
    });
})(angular);
