(() => {
    'use strict';
    angular.module('noc.components').directive('nocAtLeastOneSelected', (ValidationKeys) => {
        const VALIDATION_KEY = ValidationKeys.NOC_AT_LEAST_ONE_SELECTED_VALIDATION_KEY;

        return {
            require: ['ngModel', '^ngForm', '^form'],
            restrict: 'A',
            link: function link(scope, element, attributes, ctrl) {
                scope.$watch(attributes.nocAtLeastOneSelected, () => {
                    descriptor.shouldValidate = true;
                    validator(descriptor.modelCtrl.$viewValue);
                });

                const ngModelCtrl = ctrl[0],
                    nocNgFormCtrl = ctrl[1],
                    formCtrl = ctrl[2];

                const descriptor = {
                    modelCtrl: ngModelCtrl,
                    formCtrl,
                    shouldValidate: true
                };

                nocNgFormCtrl.addInput(descriptor, VALIDATION_KEY);

                const validator = (newValue) => {
                    nocNgFormCtrl.validate(descriptor, newValue, VALIDATION_KEY);

                    return newValue;
                };

                ngModelCtrl.$parsers.push(validator);
                ngModelCtrl.$formatters.push(validator);

                scope.$on('$destroy', () => {
                    nocNgFormCtrl.removeInput(descriptor, VALIDATION_KEY);
                });
            }
        };
    });
})();
