(() => {
    'use strict';

    angular.module('noc').controller('CloudProviderAccountsAddAccountController', ($scope, CloudProviderAccountResource, nocHttp) => {

        $scope.initialize = () => {
            CloudProviderAccountResource.getFormattedAccounts(nocHttp)
                .then((accounts) => {
                    if (accounts.length === 0) {
                        $scope.firstAccount = true;
                    }
                });
        };

        $scope.goToCreateAzureAccount = () => {
            $scope.checkAndSetState('cloud-provider-accounts.add-azure-account');
        };

        $scope.goToCreateGcpAccount = () => {
            $scope.checkAndSetState('cloud-provider-accounts.add-gcp-account');
        };

        $scope.goToCreateAwsAccount = () => {
            $scope.checkAndSetState('cloud-provider-accounts.add-aws-account');
        };

        $scope.goToCreateNssAccount = () => {
            $scope.checkAndSetState('cloud-provider-accounts.add-nss-account');
        };

        $scope.goToAddCloudProviderAccount = () => {
            $scope.checkAndSetState('cloud-provider-accounts.add');
        };

        $scope.goToCloudProviderAccountSettings = () => {
            $scope.checkAndSetState('cloud-provider-accounts.account-settings');
        };

        $scope.tabs = [
            {tabName: 'working-environments', title: 'Working Environments'},
            {tabName: 'replication-status', title: 'Replication Status'},
            {tabName: 'k8s-clusters', title: 'Kubernetes Clusters'},
            {tabName: 'timeline', title: 'Timeline'}
        ];

        $scope.onTabClick = (tab) => {
            $scope.checkAndSetState('main.' + tab.tabName + (tab.tabName !== 'timeline' ? '.index' : ''));
        };

        $scope.cancel = () => {
            if ($scope.firstAccount) {
                $scope.goToAddCloudProviderAccount();
            } else {
                $scope.goToCloudProviderAccountSettings();
            }
        };

        $scope.initialize();
    });
})();
