(function () {
    "use strict";

    angular.module('noc').factory("usageProfiles", function () {
        var profiles = [
            {
                display: 'Storage Efficiency',
                description: 'Enable thin provisioning, deduplication, and compression',
                tooltip: 'Enable thin provisioning, deduplication, and compression',
                flags: {
                    enableThinProvisioning: true,
                    enableDeduplication: true,
                    enableCompression: true
                }
            },
            {
                display: 'No Storage Efficiency',
                description: 'Use fully provisioned capacity',
                tooltip: 'Does not enable thin provisioning, deduplication or compression',
                flags: {
                    enableThinProvisioning: false,
                    enableDeduplication: false,
                    enableCompression: false
                }
            }
        ];

        function fromFlags(enableThinProvisioning, enableDeduplication, enableCompression){
            return _.find(profiles,{
                flags:{
                    enableThinProvisioning: enableThinProvisioning,
                    enableDeduplication: enableDeduplication,
                    enableCompression: enableCompression
                }
            });
        }

        return {
            fromFlags: fromFlags,
            list:profiles,
            default: profiles[0]
        };
    });
})();
