(() => {
    'use strict';

    angular.module('noc').controller('AwsMultiAccountDialogContentController', ($scope) => {
        $scope.initialize = () => {
            _.forEach($scope.dialogScope.awsAccounts, (account) => {
                account._accountDisplayName = account.accountName + (account.accountId ? ' | Account ID: ' + account.accountId : '');
            });
            $scope.dialogScope.selectedAWSAccountOriginal = $scope.dialogScope.selectedAWSAccount;
        };

        $scope.closeAWSAccountDialog = () => {
            $scope.dialogScope.selectedAWSAccount = $scope.dialogScope.selectedAWSAccountOriginal;
            $scope.closeDialog();
        };

        $scope.saveAWSAccount = () => {
            $scope.wizardController.selectedAWSAccountId = $scope.dialogScope.selectedAWSAccount.accountId;
            if ($scope.dialogScope.discover) {
                $scope.dialogScope.handleRegionChange($scope.dialogScope.selectedRegion, true);
            } else {
                $scope.wizardController.setWizardStep($scope.wizardController.path['create-detailsCredentials']);
                $scope.wizardController.clearStepData('vpc');
            }
            $scope.closeDialog();
        };

        $scope.goToProviderAccountsSettings = () => {
            $scope.checkAndSetState('cloud-provider-accounts.account-settings');
            $scope.closeDialog();
        };

        $scope.initialize();
    });
})();
