(() => {
    'use strict';

    angular.module('noc').controller('azureSubscriptionController', ($scope, MetadataResource, nocHttp, pidgeon) => {
        $scope.initialize = () => {
            _.forEach($scope.dialogScope.azureAccounts, (account) => {
                account._accountDisplayName = account.accountName + (account.applicationId ? ' | Application ID: ' + account.applicationId : '');
            });
            $scope.dialogScope.selectedAzureAccountOriginal = $scope.dialogScope.selectedAzureAccount;
        };

        $scope.loadSubscriptions = () => {
            return MetadataResource.getAssociatedSubscriptionsForAzure(nocHttp, pidgeon, $scope.dialogScope.selectedAzureAccount.publicId)
                .then((subscriptionsResponse) => {
                    pidgeon.clear();
                    $scope.dialogScope.associatedSubscriptions = subscriptionsResponse;
                    $scope.dialogScope.defaultAzureSubscription = _.find($scope.dialogScope.associatedSubscriptions, {default: true});
                    $scope.dialogScope.currentAzureSubscription = $scope.dialogScope.defaultAzureSubscription || $scope.dialogScope.associatedSubscriptions[0];
                })
                .catch(() => {
                    $scope.dialogScope.associatedSubscriptions = null;
                    $scope.dialogScope.currentAzureSubscription = null;
                });
        };

        $scope.saveChanges = () => {
            $scope.dialogScope.isAzureSubscriptionChanged = $scope.wizardController.selectedAzureSubscription !== $scope.dialogScope.currentAzureSubscription;
            $scope.wizardController.selectedAzureSubscription = $scope.dialogScope.currentAzureSubscription;
            if ($scope.dialogScope.discover) {
                $scope.dialogScope.handleRegionChange($scope.dialogScope.selectedRegion, true);
            } else {
                $scope.wizardController.setWizardStep($scope.wizardController.path['create-detailsCredentials']);
                $scope.wizardController.clearStepData('vnet');
            }
            $scope.closeDialog();
        };

        $scope.closeAzureAccountDialog = () => {
            $scope.dialogScope.selectedAzureAccount = $scope.dialogScope.selectedAzureAccountOriginal;
            $scope.dialogScope.currentAzureSubscription = $scope.wizardController.selectedAzureSubscription;
            $scope.closeDialog();
        };

        $scope.goToProviderAccountsSettings = () => {
            $scope.checkAndSetState('cloud-provider-accounts.account-settings');
            $scope.closeDialog();
        };

        $scope.initialize();
    });
})();
