(() => {
    'use strict';

    angular.module('noc').controller('DiscoverK8sClusterController', ($scope, nocUploader, nocHttp,
                                                                      nocDialog, KubernetesResource) => {
        $scope.initialize = () => {
            $scope.loaded = true;
            nocUploader.call($scope, nocHttp);
        };

        $scope.onUploadK8tConfig = () => {
            $('#hiddenConfigInputButton').click();
        };

        $scope.uploadConfigFile = (e) => {
            if (e.files[0]) {
                $scope.configFile = e.files[0];
            }
            angular.element(e).val(null);
            $scope.loading = true;

            const descriptors = [{
                fieldName: 'filename',
                file: $scope.configFile,
                uploadFormField: 'config'
            }];
            const uploadUrl = '/k8s/load';

            $scope.upload('', descriptors, uploadUrl)
                .then((k8sFileInfo) => {
                    $scope.existingConfiguration = true;
                    $scope.fileInfo = k8sFileInfo.contexts[0];
                    $scope.data = {
                        k8sconfig: k8sFileInfo.k8sconfig,
                        contextNames: [$scope.fileInfo.contextName]
                    };
                    $scope.loading = false;
                    $scope.uploadError = null;
                    if (!$scope.fileInfo.connectivity) {
                        $scope.noConnectivity = true;
                    } else if ($scope.fileInfo.alreadyExists) {
                        $scope.alreadyExists = true;
                    } else {
                        $scope.noConnectivity = null;
                        $scope.alreadyExists = null;
                    }
                })
                .catch((error) => {
                    $scope.loading = false;
                    $scope.uploadError = error.message;
                });
        };

        $scope.saveCluster = () => {
            KubernetesResource.saveK8sClusters(nocHttp, $scope.data)
                .then(() => {
                    $scope.checkAndSetState('main.k8s-clusters.k8s-cluster-settings');
                });
        };

        $scope.initialize();
    });
})();
