(function () {
    "use strict";

    angular.module("noc").service("auditTemplateFinder", function ($injector, AuditTemplatesLatest, AuditRecordTemplatesLatest) {
        var missingActionName =                 "<span class='audit-text-missing-template' title='Action name is not defined'>Missing action name</span>";
        var templateNotFound =                  "<span class='audit-text-missing-template' title='No Template defined for action'>{{data.actionName}}</span>";
        var template =                          "<span>{{data.actionName}}</span>";

        var templatesCache = {};
        return {
            find: function (actionName, version){
                var templateVersion = "AuditTemplates-" + version;
                var templates = templatesCache[templateVersion];
                if(!templates){
                    if($injector.has(templateVersion)){
                        templates = templatesCache[templateVersion] = $injector.get(templateVersion);
                    }else{
                        templates = templatesCache[templateVersion] = AuditTemplatesLatest;
                    }
                }

                return actionName ? templates[actionName] || templateNotFound : missingActionName;

            },
            findRecord: function(actionName) {
                var templateVersion = "AuditRecordTemplates";
                var templates = templatesCache[templateVersion];
                if(!templates){
                    if($injector.has(templateVersion)){
                        templates = templatesCache[templateVersion] = $injector.get(templateVersion);
                    }else{
                        templates = templatesCache[templateVersion] = AuditRecordTemplatesLatest;
                    }
                }

                return templates[actionName] || template;
            },
            templates: AuditTemplatesLatest,
            recordTemplates: AuditRecordTemplatesLatest
        };
    });
}());
