(() => {
    'use strict';

    angular.module('noc').service('AuditTemplatesLatest', (Constants) => {
        var createReplicationTemplate =         "<span><span class='audit-text-action-name'>Create replication</span> from volume <span class='audit-text-value'>{{data._jsonParameters.replicationVolume.sourceVolumeName}}</span> to volume <span class='audit-text-value'>{{data._jsonParameters.replicationVolume.destinationVolumeName}}</span>";
        var nameForInstanceTemplate =           "<span ng-if='data._jsonParameters.instanceType.indexOf(\"_\") > -1'>VM</span><span ng-if='data._jsonParameters.instanceType.indexOf(\"_\") === -1'>instance</span>"; // Azure instance type contains '_'
        return {
            "Login" :                           "<span>User <span class='audit-text-value'>{{data.userName}}</span> <span class='audit-text-action-name'>logged in</span></span>",
            "Initial Setup" :                   "<span><span class='audit-text-action-name'>Initial setup</span></span>",
            "Initial Setup With Portal" :       "<span><span class='audit-text-action-name'>Initial setup with portal</span></span>",
            "Initial Standalone Setup With Portal" : "<span><span class='audit-text-action-name'>Initial standalone setup with portal</span></span>",
            "Volume View Initial Setup" :       "<span><span class='audit-text-action-name'>Volume view initial setup</span></span>",
            "Logout" :                          "<span>User <span class='audit-text-value'>{{data.userName}}</span> <span class='audit-text-action-name'>logged out</span></span>",
            "Backup Database" :                 "<span><span class='audit-text-action-name'>Backup</span> Cloud Manager database</span>",
            "Restore Database" :                "<span><span class='audit-text-action-name'>Restore</span> Cloud Manager database file: <span class='audit-text-value'>{{data._jsonParameters.filename}}</span></span>",
            "Set Simplicator Config" :          "<span><span class='audit-text-action-name'>Configuration update</span></span>",
            "Reset Simplicator Config" :        "<span><span class='audit-text-action-name'>Reset simplicator URL</span></span>",
            "Add Tenant" :                      "<span><span class='audit-text-action-name'>Create new tenant</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Update Tenant" :                   "<span><span class='audit-text-action-name'>Update tenant</span> information for <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Tenant" :                   "<span><span class='audit-text-action-name'>Delete tenant</span> <span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Validate Tenant":                  "<span><span class='audit-text-action-name'>Validate tenant</span> <span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Create User" :                     "<span><span class='audit-text-action-name'>Create user</span> <span class='audit-text-value'>{{data._jsonParameters.firstName}} {{data._jsonParameters.lastName}}</span> of role <span class='audit-text-value'>{{data._jsonParameters.roleName}}</span></span>",
            "Add User" :                        "<span><span class='audit-text-action-name'>Add user</span> <span class='audit-text-value'>{{data._jsonParameters.email}}</span> of role <span class='audit-text-value'>{{data._jsonParameters.roleName}}</span></span>",
            "Remove User" :                     "<span><span class='audit-text-action-name'>Remove user</span> <span class='audit-text-value'>{{data._jsonParameters.email}}</span></span>",
            "Update User" :                     "<span><span class='audit-text-action-name'>Updated information for user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span> of role <span class='audit-text-value'>{{data._jsonParameters.roleName}}</span></span>",
            "Update User Volume View" :         "<span><span class='audit-text-action-name'>Updated information for user</span></span>",
            "Delete User" :                     "<span><span class='audit-text-action-name'>Delete user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Change Current User Keys" :        "<span><span class='audit-text-action-name'>Change AWS keys</span> for user <span class='audit-text-value'>{{data.userName}}</span></span>",
            "Change Current User Azure Credentials" : "<span><span class='audit-text-action-name'>Change Azure credentials</span> for user <span class='audit-text-value'>{{data.userName}}</span></span>",
            "Change Keys" :                     "<span><span class='audit-text-action-name'>Change AWS keys</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Change Azure Credentials" :       "<span><span class='audit-text-action-name'>Change Azure credentials</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Update Cost" :                     "<span><span class='audit-text-action-name'>Update cost</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Reset Password" :                  "<span><span class='audit-text-action-name'>Reset Cloud Manager password</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Grant Permission" :                "<span>" +
                                                "<span class='audit-text-action-name'>Permissions updated</span> for user " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.userName}}:</span>" +
                                                "<span ng-if='data._jsonParameters.addWorkingEnvironmentNames.length'> granted to working environment(s) " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.addWorkingEnvironmentNames}}</span>" +
                                                "</span>" +
                                                "<span ng-if='data._jsonParameters.addWorkingEnvironmentNames.length && data._jsonParameters.removeWorkingEnvironmentNames.length'> and</span>" +
                                                "<span ng-if='data._jsonParameters.removeWorkingEnvironmentNames.length'> revoked from working environment(s) " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.removeWorkingEnvironmentNames}}</span>" +
                                                "</span>" +
                                                "</span>",
            "Change Current User Password" :    "<span><span class='audit-text-action-name'>Change Cloud Manager password</span></span>",
            "Create Vsa Working Environment" :  "<span><span class='audit-text-action-name'>Create new working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span> of type Cloud Volumes ONTAP</span>",
            'Delete Vsa Working Environment':   '<span><span class="audit-text-action-name"><span ng-if="data._jsonParameters.localDelete === \'true\'">Remove</span><span ng-if="data._jsonParameters.localDelete !== \'true\'">Delete</span> working environment</span> <span class="audit-text-value">{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if=\'data._jsonParameters.localDelete\'> from Cloud Manager</span></span>',
            'Delete Aws Ha Working Environment':
                                                '<span><span class="audit-text-action-name"><span ng-if="data._jsonParameters.localDelete === \'true\'">Remove</span><span ng-if="data._jsonParameters.localDelete !== \'true\'">Delete</span> highly available working environment</span> <span class="audit-text-value">{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if="data._jsonParameters.localDelete"> from Cloud Manager</span></span>',
            "Delete Failed W E" :               "<span><span class='audit-text-action-name'>Delete failed working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Stop Vsa" :                        "<span><span class='audit-text-action-name'>Stop Cloud Volumes ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Stop Aws Ha":                      "<span><span class='audit-text-action-name'>Stop highly available Cloud Volumes ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Start Aws Ha":                     "<span><span class='audit-text-action-name'>Start highly available Cloud Volumes ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Suspend Cloud Volumes ONTAP due to subscription expiry" :  "<span><span class='audit-text-action-name'>Suspend Cloud Volumes ONTAP due to subscription expiry </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Update Cloud subscription":        "<span class='audit-text-action-name'>Update Cloud subscription</span>",
            "Validate Floating Ips":            "<span class='audit-text-action-name'>Validate floating IPs</span>",
            "Sync Vsa Working Environments Subscription":
                "<span class='audit-text-action-name'>Sync Vsa Working Environments Subscription</span>",
            "Start Vsa" :                       "<span><span class='audit-text-action-name'>Start Cloud Volumes ONTAP for working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Update Vsa Configuration" :        "<span><span class='audit-text-action-name'>Update Cloud Volumes ONTAP backup configuration</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Quote Volume":                     "<span>" +
                                                "<span class='audit-text-action-name'>Calculate required capacity</span> to accommodate volume <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "<span ng-if=\"data._jsonParameters.aggregateName\"> on aggregate <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>" +
                                                "</span>",
            "Create Volume" :                   "<span>" +
                                                "<span class='audit-text-action-name'>Create volume</span>" +
                                                " <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "<span ng-if=\"data._jsonParameters.aggregateName && !data._jsonParameters.createAggregateIfNotFound\"> on aggregate <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>" +
                                                "<span ng-if=\"data._jsonParameters.autoVsaCapacityManagementEnabled === false && data._jsonParameters.maxNumOfDisksApprovedToAdd !== undefined && data._jsonParameters.maxNumOfDisksApprovedToAdd >= 0\">" +
                                                ' with approval to purchase <span class="audit-text-value">{{data._jsonParameters.maxNumOfDisksApprovedToAdd}} disk{{data._jsonParameters.maxNumOfDisksApprovedToAdd !== 1 ? "s" : ""}}</span>' +
                                                "</span>" +
                                                "</span>",
            "Create Managed Volume" :           "<span>" +
                                                "<span class='audit-text-action-name'>Create volume</span>" +
                                                " <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "</span>",
            "Create Managed Ha Volume" :        "<span>" +
                                                "<span class='audit-text-action-name'>Create highly available volume</span>" +
                                                " <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "</span>",
            "Possible Placement" :              "<span><span class='audit-text-action-name'>Possible volume placement</span></span>",
            "Quote" :                           "<span><span class='audit-text-action-name'>Quote volume</span></span>",
            "Ha Possible Placement" :           "<span><span class='audit-text-action-name'>Possible highly available volume placement</span></span>",
            "Delete Volume" :                   "<span><span class='audit-text-action-name'>Delete volume</span> <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span>",
            "Delete Managed Volume" :           "<span><span class='audit-text-action-name'>Delete volume</span> <span class='audit-text-value'>{{data._jsonParameters.managedVolumeId.split(':')[2]}}</span></span>",
            "Modify Volume" :                   "<span><span class='audit-text-action-name'>Modify volume</span> <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span>",
            "Modify Managed Volume" :           "<span><span class='audit-text-action-name'>Modify volume</span> <span class='audit-text-value'>{{data._jsonParameters.managedVolumeId.split(':')[2]}}</span></span>",
            "Clone Volume" :                    "<span><span class='audit-text-action-name'>Clone volume</span> <span class='audit-text-value'>{{data._jsonParameters.parentvolume || data._jsonParameters.volumeName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.parentvolume ? data._jsonParameters.volumeName : data._jsonParameters.newVolumeName}}</span></span>",
            "Clone Managed Volume" :            "<span><span class='audit-text-action-name'>Clone volume</span> <span class='audit-text-value'>{{data._jsonParameters.parentvolume || data._jsonParameters.managedVolumeId.split(':')[2]}}</span> to <span class='audit-text-value'>{{data._jsonParameters.parentvolume ? data._jsonParameters.managedVolumeId.split(':')[2] : data._jsonParameters.newVolumeName}}</span></span>",
            "Assign Network Configuration To Tenant":
                                                "<span><span class='audit-text-action-name'>Assign network configuration</span></span>",
            "Set Password":                     "<span><span class='audit-text-action-name'>Setting cluster admin password for working environment </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Set Ontap Cloud Password":         "<span><span class='audit-text-action-name'>Set Cloud Volumes ONTAP password </span></span>",
            "Set Volume View Aws Tags":         "<span><span class='audit-text-action-name'>Set Volume View AWS Tags</span></span>",
            "Update Password":                  "<span><span class='audit-text-action-name'>Update credentials for ONTAP working environment </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Create Aggregate":                 "<span class='audit-text-action-name'>Create aggregate </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span>",
            "Manually Activate Auto Vsa Capacity Management Cycle": "<span><span class='audit-text-action-name'>Manually activate VSA capacity automatic management cycle</span></span>",
            "Automatically Add Disks To Aggregate": "<span><span class='audit-text-action-name'>Automatically add disks to aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Automatically Delete Empty Aggregate": "<span><span class='audit-text-action-name'>Automatically delete aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Automatically Move Volume":        "<span><span class='audit-text-action-name'>Automatically move volume</span> from <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Add Disks To Aggregate":           "<span><span class='audit-text-action-name'>Add disks to aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Delete Aggregate":                 "<span><span class='audit-text-action-name'>Delete aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Add Extension":                    "<span><span class='audit-text-action-name'>Add extension</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Extension":                 "<span><span class='audit-text-action-name'>Delete extension</span></span>",
            "Update Extension":                 "<span><span class='audit-text-action-name'>Update extension</span></span>",
            "Execute Extension":                "<span><span class='audit-text-action-name'>Execute extension</span>",
            "Send Asup":                        "<span><span class='audit-text-action-name'>Send AutoSupport file</span>",
            "Save Asup Configuration":          "<span><span class='audit-text-action-name'>Save Send Support Information configuration</span>",
            "Download Asup File":               "<span><span class='audit-text-action-name'>Download AutoSupport file</span>",
            "Patch":                            "<span><span class='audit-text-action-name'>Manual Cloud Manager software update</span><span class='audit-text-value'> <span ng-show='data._jsonParameters.from.version'> from {{data._jsonParameters.from.version}} ({{data._jsonParameters.from.build | limitTo:7}})</span><span ng-show='data._jsonParameters.to.version'> to {{data._jsonParameters.to.version}} ({{data._jsonParameters.to.build | limitTo:7}})</span> using file {{data._jsonParameters.filename}}</span>",
            "Update Version":                   "<span><span class='audit-text-action-name'>Automatic Cloud Manager software update</span><span class='audit-text-value'> <span ng-show='data._jsonParameters.from.version'> from {{data._jsonParameters.from.version}} ({{data._jsonParameters.from.build | limitTo:7}})</span><span ng-show='data._jsonParameters.to.version'> to {{data._jsonParameters.to.version}} ({{data._jsonParameters.to.build | limitTo:7}})</span> using file {{data._jsonParameters.filename}}</span>",
            "Delete Failed Working Environment":"<span><span class='audit-text-action-name'>Delete failed working environment</span></span>",
            "Set Config Value":                 "<span>" +
                                                "<span ng-if=\"data._jsonParameters.key === 'max_aggr_over_commitment_capacity_percentage' || data._jsonParameters.key === 'max_aggr_free_space_percentage'\"><span>Capacity threshold <span class='audit-text-action-name'>{{data._jsonParameters.key | translateKey}}</span> changed to <span class='audit-text-value'>{{data._jsonParameters.value}}%</span></span></span>" +
                                                "<span ng-if=\"data._jsonParameters.key === 'key_manager_port'\"><span><span class='audit-text-action-name'>Key Manager port</span> changed to <span class='audit-text-value'>{{data._jsonParameters.value}}</span></span></span>" +
                                                "</span>",
            "Update Config":                    "<span><span class='audit-text-action-name'>Update Cloud Manager configuration values</span></span>",
            "Recover":                          "<span><span class='audit-text-action-name'>Discover Cloud Volumes ONTAP working environment</span> <span class='audit-text-value' ng-if='data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName'>{{data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName}}</span></span>",
            "Discover Azure":                   "<span><span class='audit-text-action-name'>Discover Cloud Volumes ONTAP working environment</span> <span class='audit-text-value' ng-if='data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName'>{{data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName}}</span></span>",
            "Verify Cluster Credentials":       "<span><span class='audit-text-action-name'>Verify cluster credentials</span></span>",
            "Set Default Proxy":                "<span><span class='audit-text-action-name'>Set proxy to </span> <span class='audit-text-value'>{{data._jsonParameters.uri !== '' ? data._jsonParameters.uri : 'None'}}</span></span>",
            "Register Support":                 "<span><span class='audit-text-action-name'>Perform automatic support registration</span> for working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Set Tenant Nss Keys":              "<span><span class='audit-text-action-name'>Set NSS support keys</span><span> for tenant </span><span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Register With Keys":               "<span><span class='audit-text-action-name'>Register to support with NSS keys</span><span>",
            "Register":                         "<span><span class='audit-text-action-name'>Register to support for working environment </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span>",
            "Discover On Prem":                 "<span><span class='audit-text-action-name'>Discover ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Remove On Prem":                   "<span><span class='audit-text-action-name'>Remove ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Retrieve On Prem":                 "<span><span class='audit-text-action-name'>Retrieve all ONTAP working environments</span> ",
            "Change S3 Bucket Name":            "<span><span class='audit-text-action-name'>Change S3 bucket name</span><span> for user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span> ",
            "Create Replication Vsa":           createReplicationTemplate,
            "Create Replication On Prem":       createReplicationTemplate,
            "Change Environment":               "<span><span class='audit-text-action-name'>Change environment to </span> <span class='audit-text-value'>{{data._jsonParameters.environment}}</span></span>",
            "Update Replication":               "<span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldSchedule !== undefined\"><span class='audit-text-action-name'>Edit replication schedule</span> from <span class='audit-text-value'>{{data._jsonParameters.oldSchedule === '' ? '" + Constants.emptyReplicationScheduleDescription + "' : data._jsonParameters.oldSchedule}}</span><span> to </span><span class='audit-text-value'>{{data._jsonParameters.schedule}}</span></span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldSchedule !== undefined && data._jsonParameters.oldMaxTransferRate !== undefined\"> and </span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldMaxTransferRate !== undefined\"><span class='audit-text-action-name'>Edit replication Transfer Rate</span> from <span class='audit-text-value'>{{data._jsonParameters.oldMaxTransferRate === 0 ? 'Unlimited' : data._jsonParameters.oldMaxTransferRate + ' KB/s'}}</span><span> to </span><span class='audit-text-value'>{{data._jsonParameters.maxTransferRate === 0 ? 'Unlimited' : data._jsonParameters.maxTransferRate + ' KB/s'}}</span></span>" +
                                                    "<span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span>" +
                                                "</span>",
            "Resync Replication":               "<span><span class='audit-text-action-name'>Resync replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Reverse Resync Replication":       "<span><span class='audit-text-action-name'>Reverse resync replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Uptodate Replication":             "<span><span class='audit-text-action-name'>Update replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Initialize Replication":           "<span><span class='audit-text-action-name'>Initialize replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Break Replication":                "<span><span class='audit-text-action-name'>Break replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Delete Replication":               "<span><span class='audit-text-action-name'>Delete replication</span> of destination volume <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span>",
            "Change License And Instance Type": "<span><span class='audit-text-action-name'>Change license and " + nameForInstanceTemplate + " type</span><span ng-show='data._jsonParameters.oldInstanceType'> from </span><span ng-show='data._jsonParameters.oldInstanceType' class='audit-text-value'>{{data._jsonParameters.oldInstanceType}}</span><span> to </span> <span class='audit-text-value'>{{data._jsonParameters.instanceType}}</span></span>",
            "Managed Change Instance Type":     "<span><span class='audit-text-action-name'>Change " + nameForInstanceTemplate + " type</span><span ng-show='data._jsonParameters.oldInstanceType'> from </span><span ng-show='data._jsonParameters.oldInstanceType' class='audit-text-value'>{{data._jsonParameters.oldInstanceType}}</span><span> to </span> <span class='audit-text-value'>{{data._jsonParameters.instanceType}}</span></span>",
            "Install Certificate":              "<span><span class='audit-text-action-name'>Install Cloud Manager certificate</span></span>",
            "Add Key Manager Ca Certificate":   "<span><span class='audit-text-action-name'>Add key manager CA certificate </span></span>",
            "Update Key Manager Ca Certificate":"<span><span class='audit-text-action-name'>Update key manager CA certificate </span></span>",
            "Update Client Certificate":        "<span><span class='audit-text-action-name'>Renew ONTAP certificate </span></span>",
            "Delete Key Manager Ca Certificate":"<span><span class='audit-text-action-name'>Delete key manager CA certificate </span></span>",
            "Add Key Manager":                  "<span><span class='audit-text-action-name'>Add key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Add Key Manager To Vsa":           "<span><span class='audit-text-action-name'>Add key manager to Cloud Volumes ONTAP </span><span class='audit-text-value'>{{data._jsonParameters.keyManagerIp}}</span> <span class='audit-text-action-name'></span></span>",
            "Delete Key Manager From Vsa":      "<span><span class='audit-text-action-name'>Delete key manager from Cloud Volumes ONTAP </span><span class='audit-text-value'>{{data._jsonParameters.keyManagerIp}}</span><span class='audit-text-action-name'></span></span>",
            "Update Key Manager":               "<span><span class='audit-text-action-name'>Update key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Key Manager":               "<span><span class='audit-text-action-name'>Delete key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Generate Csr":                     "<span><span class='audit-text-action-name'>Generate CSR </span></span>",
            "Update System Image":              "<span><span class='audit-text-action-name'>Update system image</span> on working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if='data._jsonParameters.fromVersion'> from <span class='audit-text-value'>{{data._jsonParameters.fromVersion}}<span ng-if=\"data._jsonParameters.fromImage && data._jsonParameters.updateType === 'LOCAL_IMAGE'\"> ({{data._jsonParameters.fromImage}}) </span></span><span ng-if='data._jsonParameters.toVersion'> to <span class='audit-text-value'>{{data._jsonParameters.toVersion}}<span ng-if=\"data._jsonParameters.updateParameter && data._jsonParameters.updateType === 'LOCAL_IMAGE'\"> ({{data._jsonParameters.updateParameter}}) </span></span></span></span></span>",
            "Update Mediator":                  "<span><span class='audit-text-action-name'>Update mediator</span> on working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if='data._jsonParameters.fromMediatorVersion'> from version <span class='audit-text-value'>{{data._jsonParameters.fromMediatorVersion}}</span></span><span ng-if='data._jsonParameters.toMediatorVersion'> to version <span class='audit-text-value'>{{data._jsonParameters.toMediatorVersion}}</span></span></span>",
            "Working Environments Report":      "<span><span class='audit-text-action-name'>Working environments report</span></span>",
            "Update Image Cloud Ontap Metadata":"<span><span class='audit-text-action-name'>Update image Cloud Volumes ONTAP metadata</span></span>",
            "Update Cloud Ontap Metadata":      "<span><span class='audit-text-action-name'>Update Cloud Volumes ONTAP metadata</span></span>",
            "Setup Cifs Configuration":         "<span><span class='audit-text-action-name'>Setup CIFS Configuration</span></span>",
            "Backup Ontap Configuration":       "<span><span class='audit-text-action-name'>Backup Cloud Volumes ONTAP Configuration</span></span>",
            "Activate Ontap Configuration":     "<span><span class='audit-text-action-name'>Set Cloud Volumes ONTAP configuration Target</span></span>",
            "Scheduled Cloud Volumes ONTAP Stop":       "<span><span class='audit-text-action-name'>Scheduled Cloud Volumes ONTAP Stop</span></span>",
            "Scheduled Cloud Volumes ONTAP Start":      "<span><span class='audit-text-action-name'>Scheduled Cloud Volumes ONTAP Start</span></span>",
            "Upload License File":              "<span><span class='audit-text-action-name'>Upload License File</span></span>",
            "Upload License File Content":      "<span><span class='audit-text-action-name'>Upload License File Content</span></span>",
            "Update Route Tables":              "<span><span class='audit-text-action-name'>Update Route Tables</span></span>",
            "Set Schedules":                    "<span><span class='audit-text-action-name'>Set Cloud Volumes ONTAP Start-Stop Schedules</span></span>",
            "Generate Keys And Certificate Request":"<span><span class='audit-text-action-name'>Generate Certificate Signing Request</span></span>",
            "Install Signed Certificate":        "<span><span class='audit-text-action-name'>Install Signed Certificate</span></span>",
            "Install Signed Certificate File":   "<span><span class='audit-text-action-name'>Install Signed Certificate File</span></span>",
            "Install External Signed Certificate":"<span><span class='audit-text-action-name'>Install External Signed Certificate</span></span>",
            "Install External Signed Certificate File":"<span><span class='audit-text-action-name'>Install External Signed Certificate File</span></span>",
            "Install Trusted Certificate File":  "<span><span class='audit-text-action-name'>Install Trusted Certificate File</span></span>",
            "Delete Trusted Certificate":       "<span><span class='audit-text-action-name'>Delete Trusted Certificate </span></span>",
            "Create Aws Ha Working Environment": "<span><span class='audit-text-action-name'>Create new highly available working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span> of type Cloud Volumes ONTAP</span>",
            "Create Azure Ha Working Environment": "<span><span class='audit-text-action-name'>Create new highly available working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span> of type Cloud Volumes ONTAP</span>",
            "Change Svm Name":                   "<span><span class='audit-text-action-name'>Modify SVM name</span> of Cloud Volumes ONTAP<span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.svmName}}</span></span>",
            "Modify Writing Speed":              "<span><span class='audit-text-action-name'>Modify write speed </span> of Cloud Volumes ONTAP <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.writingSpeedState| __capitalize}}</span></span>",
            "Move Volume":                       "<span><span class='audit-text-action-name'>Move volume</span><span class='audit-text-value'> {{data._jsonParameters.volumeName}}</span> of <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span ng-if=\"data._jsonParameters.createTargetAggregate === 'true'\">a new</span> aggregate <span class='audit-text-value'>{{data._jsonParameters.targetAggregateName}}</span></span>",
            "Change Volume Tier":                "<span>" +
                                                    "<span class='audit-text-action-name'>Change volume disk type and tiering policy</span>" +
                                                    "<span ng-if='data._jsonParameters.volumeName'> of <span class='audit-text-value'> {{data._jsonParameters.volumeName}}</span></span>" +
                                                    "<span ng-if='data._jsonParameters.newDiskTypeName'> to " +
                                                        "<span class='audit-text-value'>{{data._jsonParameters.newDiskTypeName.indexOf('_') === -1 ? data._jsonParameters.newDiskTypeName : data._jsonParameters.newDiskTypeName.substring(0, data._jsonParameters.newDiskTypeName.indexOf('_')).toLowerCase()}}</span> " +
                                                        "<span class='audit-text-value'><span ng-if='data._jsonParameters.newCapacityTier'>+</span><span>{{data._jsonParameters.newCapacityTier}}</span></span>" +
                                                        "<span ng-if='data._jsonParameters.newTieringPolicy'> with tiering policy </span><span class='audit-text-value' ng-if='data._jsonParameters.newTieringPolicy'>{{data._jsonParameters.newTieringPolicy}}</span>" +
                                                    "</span>" +
                                                 "</span>",
            "Create Snapshot":                   "<span><span class='audit-text-action-name'>Create snapshot for volume </span><span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Delete Snapshot":                   "<span><span class='audit-text-action-name'>Delete snapshot for volume </span><span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Change Disk Type":                  "<span><span class='audit-text-action-name'>Change disk type</span><span ng-if='data._jsonParameters.volumeName'> of <span class='audit-text-value'> {{data._jsonParameters.volumeName}}</span></span><span ng-if='data._jsonParameters.newDiskTypeName'> to <span class='audit-text-value'>{{data._jsonParameters.newDiskTypeName.indexOf('_') === -1 ? data._jsonParameters.newDiskTypeName : data._jsonParameters.newDiskTypeName.substring(0, data._jsonParameters.newDiskTypeName.indexOf('_')).toLowerCase()}}</span></span></span>",
            "Send Ontap Cloud Asup" :            "<span><span class='audit-text-action-name'>Send Cloud Ontap Asup</span></span>",
            "Auto Upgrade" :                     "<span><span class='audit-text-action-name'>Auto Upgrade</span></span>",
            "Check Connection To Active Directory" :  "<span><span class='audit-text-action-name'>Check Connection To Active Directory</span></span>",
            "Patch Active Directory Entry" :  "<span><span class='audit-text-action-name'>Update Active Directory Details</span></span>",
            "Restart Server" :                   "<span><span class='audit-text-action-name'>Restart Server</span></span>",
            "Create Active Directory Connection" :    "<span><span class='audit-text-action-name'>Add Active Directory Connection</span></span>",
            "Delete Active Directory Entry" :    "<span><span class='audit-text-action-name'>Remove Active Directory Connection</span></span>",
            "Parse License File" :               "<span><span class='audit-text-action-name'>Parse License File</span></span>",
            "Change Network Optimization Level" :   "<span><span class='audit-text-action-name'>Change Network Optimization Level</span></span>",
            "Check Connectivity" :               "<span><span class='audit-text-action-name'>Check connectivity</span> for working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span>",
            "Cloud Sync Login" :                 "<span><span class='audit-text-action-name'>Log in <span class='audit-text-value'>{{data._jsonParameters.userFullName}}</span> to Cloud Sync service</span></span>",
            "Cloud Sync Sign Up" :               "<span><span class='audit-text-action-name'>Sign up <span class='audit-text-value'>{{data._jsonParameters.userFullName}}</span> to Cloud Sync service</span></span>",
            "Is Cloud Sync User" :               "<span><span class='audit-text-action-name'>Check if <span class='audit-text-value'>{{data._jsonParameters.userFullName}} is Cloud Sync user</span></span>",
            "Sync":                              "<span><span class='audit-text-action-name'>Sync working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span></span>",
            "Sync Delete":                       "<span><span class='audit-text-action-name'>Delete Sync from working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span></span>",
            "Add Relationship":                  "<span><span class='audit-text-action-name'>Add Cloud Sync relationship to volume <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Delete Relationship":               "<span><span class='audit-text-action-name'>Delete Cloud Sync relationship from volume <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Sync On Prem":                      "<span><span class='audit-text-action-name'>Sync ONTAP working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span></span>",
            "Sync On Prem Delete":               "<span><span class='audit-text-action-name'>Delete Sync from ONTAP working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span></span>",
            "Add On Prem Relationship":          "<span><span class='audit-text-action-name'>Add Cloud Sync relationship to volume <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Delete On Prem Relationship":       "<span><span class='audit-text-action-name'>Delete Cloud Sync relationship from volume <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span></span>",
            "Asup Trigger":                      "<span><span class='audit-text-action-name'>Trigger AutoSupport file</span></span>",
            "Validate Subscribed To Ontap Cloud":"<span><span class='audit-text-action-name'>Validate account is subscribed to Cloud Volumes ONTAP</span></span>",
            "Modify User Tags":                  "<span><span class='audit-text-action-name'>Modify tags</span> for working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Setup Workgroup Cifs Configuration":"<span><span class='audit-text-action-name'>Setup Workgroup Cifs Configuration</span></span>",
            "Ask for ASUP":                      "<span><span class='audit-text-action-name'>Ask all Cloud Volumes ONTAPs to send AutoSupport to OCCM</span></span>",
            "Receive Asup From Ontap Cloud":     "<span><span class='audit-text-action-name'>Receive AutoSupport From Cloud Volumes ONTAP</span></span>",
            "Receive Performance Asup From Ontap Cloud":     "<span><span class='audit-text-action-name'>Receive Performance AutoSupport From Cloud Volumes ONTAP</span></span>",
            "Download Ontap Cloud Asups":        "<span><span class='audit-text-action-name'>Download Cloud Volumes ONTAP AutoSupport</span></span>",
            "Change Serial Number":              "<span><span class='audit-text-action-name'>Change Serial Number</span></span>",
            "Fabric Pool Resources Cleanup":     "<span><span class='audit-text-action-name'>Fabric Pool Resources Cleanup</span></span>",
            "Enable Capacity Tiering":           "<span><span class='audit-text-action-name'>Enable capacity tiering</span> for working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Send Ontap Cloud Performance Asup": "<span><span class='audit-text-action-name'>Send AutoSupport Performance Archive file</span></span>",
            "Download Ontap Cloud Performance Asup": "<span><span class='audit-text-action-name'>Download AutoSupport Performance Archive file</span></span>",
            "Auto update system image":          "<span><span class='audit-text-action-name'>Auto update system image</span> on working environment <span class='audit-text-value'>{{data._jsonParameters.name}}</span> from <span class='audit-text-value'>{{data._jsonParameters.fromVersion}}</span> to <span class='audit-text-value'>{{data._jsonParameters.toVersion}}</span>",
            "Send Daily Notification":           "<span><span class='audit-text-action-name'>Send Daily Notification</span></span>",
            "Perform Auto Upgrade":              "<span><span class='audit-text-action-name'>Perform Auto Upgrade</span></span>",
            "Retrieve Cloud Storage Information":        "<span><span class='audit-text-action-name'>Collect Cloud Storage Automation data</span></span>",
            "Snapshot Used Capacity Calculation":        "<span><span class='audit-text-action-name'>Calculate Cloud Storage Automation data</span></span>",
            "Collect Cloud Storage Automation Data":     "<span><span class='audit-text-action-name'>Collect Cloud Storage Automation data</span></span>",
            "Calculate Cloud Storage Automation Data":   "<span><span class='audit-text-action-name'>Calculate Cloud Storage Automation data</span></span>",
            "Save Disk Info":                    "<span><span class='audit-text-action-name'>Receive Disk Information From Cloud Storage Automation Agent</span></span>",
            "Save Agent Log":                    "<span><span class='audit-text-action-name'>Receive Log File From Cloud Storage Automation Agent</span></span>",
            "Cancel Data Collection Process":    "<span><span class='audit-text-action-name'>Cancel Cloud Storage Automation process</span></span>",
            "Save Cloud Storage Automation Configuration":        "<span><span class='audit-text-action-name'>Save Cloud Storage Automation Configuration</span></span>",
            "Update Redirect Uris":              "<span><span class='audit-text-action-name'>Update Redirect URIs</span></span>",
            "Portal Setup As Service":           "<span><span class='audit-text-action-name'>Portal Setup As Service</span></span>",
            "Portal Setup As Agent":             "<span><span class='audit-text-action-name'>Portal Setup As Service Control Unit</span></span>",
            "Complete Connectivity Pending Setup": "<span><span class='audit-text-action-name'>Complete Connectivity Pending Setup</span></span>",
            "Scheduled Retrieve Cloud Storage Information":      "<span><span class='audit-text-action-name'>Scheduled Collect Cloud Storage Automation data</span></span>",
            "Scheduled Collect Cloud Storage Automation Data":      "<span><span class='audit-text-action-name'>Scheduled Collect Cloud Storage Automation data</span></span>",
            "Data Migration":                    "<span><span class='audit-text-action-name'>Data Migration</span> from <span class='audit-text-value'>{{data._jsonParameters.instanceIp}}</span>:<span class='audit-text-value'>{{data._jsonParameters.sourceExportPath}}</span> to working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Delete Cloud Provider Volumes":     "<span><span class='audit-text-action-name'>Delete Cloud Provider Volumes</span></span>",
            "Add Aws Account":                   "<span><span class='audit-text-action-name'>Add AWS Account</span></span>",
            "Delete Unassociated Volumes":       "<span><span class='audit-text-action-name'>Delete Unassociated Volumes</span></span>",
            "Delete Unassociated Snapshots":     "<span><span class='audit-text-action-name'>Delete Unassociated Snapshots</span></span>",
            "Migrate To Cloud Central":          "<span><span class='audit-text-action-name'>Migrate Cloud Manager Users Authentication To Cloud Central</span></span>",
            "Update Users Info":                 "<span><span class='audit-text-action-name'>Update Users Info From Cloud Central</span></span>",
            "Change Tier Level":                 "<span><span class='audit-text-action-name'>Change Tier Level</span></span>",
            "Create Virtual Network":            "<span><span class='audit-text-action-name'>Create Virtual Network</span></span>",
            "Handle SIDL Compliance":            "<span><span class='audit-text-action-name'>Handle SIDL Compliance</span></span>",
            "Create Snapshot Policy":            "<span><span class='audit-text-action-name'>Create Snapshot Policy</span></span>",
            "Register Agent":                    "<span><span class='audit-text-action-name'>Register Agent</span></span>",
            "Set Agents Logging Level":          "<span><span class='audit-text-action-name'>Set Logging Level for Agents</span></span>",
            "Kubernetes Setup":                         "<span><span class='audit-text-action-name'>Kubernetes Setup</span></span>",
            "Remove Kubernetes Configuration":          "<span><span class='audit-text-action-name'>Remove Kubernetes Configuration</span></span>",
            "Kubernetes Load File":                     "<span><span class='audit-text-action-name'>Load Kubernetes Configuration File</span></span>",
            "Kubernetes Save":                          "<span><span class='audit-text-action-name'>Save Kubernetes Cluster Configuration</span></span>",
            "Delete Kubernetes Cluster Configuration":  "<span><span class='audit-text-action-name'>Delete Kubernetes Cluster Configuration</span></span>",
            "Connect Ontap Cloud To Kubernetes":        "<span><span class='audit-text-action-name'>Connect Cloud Volumes ONTAP to Kubernetes Cluster</span></span>",
            "Disconnect Ontap Cloud From Kubernetes":   "<span><span class='audit-text-action-name'>Disconnect Cloud Volumes ONTAP from Kubernetes Cluster</span></span>",
            "Create Aws Account":                       "<span><span class='audit-text-action-name'>Create AWS Cloud Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Create Azure Account":                     "<span><span class='audit-text-action-name'>Create Azure Cloud Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Create Nss Account":                       "<span><span class='audit-text-action-name'>Create NSS Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Update Aws Account":                       "<span><span class='audit-text-action-name'>Update AWS Cloud Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Update Azure Account":                     "<span><span class='audit-text-action-name'>Update Azure Cloud Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Update Nss Account":                       "<span><span class='audit-text-action-name'>Update NSS Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Delete Account":                           "<span><span class='audit-text-action-name'>Delete Cloud Provider Account</span> <span class='audit-text-value'>{{data._jsonParameters.accountName}}</span> </span>",
            "Working Environment Cost And Usage":       "<span><span class='audit-text-action-name'>Working Environment Cost And Usage</span></span>",
            "Working Environment Ontap Saving":         "<span><span class='audit-text-action-name'>Working Environment Ontap Saving</span></span>",
            "Activate Snapshot Policy":                 "<span><span class='audit-text-action-name'>Activate Snapshot Policy</span></span>",
            "Activate Fpolicy":                         "<span><span class='audit-text-action-name'>Activate FPolicy</span></span>",
            "Configure Aws Fabric Pool":                "<span><span class='audit-text-action-name'>Configure ONTAP Fabric Pool using AWS</span></span>",
            "Configure Azure Fabric Pool":              "<span><span class='audit-text-action-name'>Configure ONTAP Fabric Pool using Azure</span></span>",
            "Disable Fpolicy":                          "<span><span class='audit-text-action-name'>Deactivate FPolicy</span></span>",
            "Delete Fpolicy":                           "<span><span class='audit-text-action-name'>Delete FPolicy</span></span>",
            "Portal Setup As Agent":                    "<span><span class='audit-text-action-name'>Portal Setup As Agent</span></span>",
            "Attach Object Store":                      "<span><span class='audit-text-action-name'>Attach Object Store</span> to <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span> </span>",
            "Apply Fabric Pool License":                "<span><span class='audit-text-action-name'>Apply Fabric Pool License</span></span>",
            "Enable Cold Data Reporting":               "<span><span class='audit-text-action-name'>Enable Cold Data Reporting</span></span>",
            "Recover failed Disk":                      "<span><span class='audit-text-action-name'>Recover failed Disk</span></span>",
            "Azure HA LB Handler":                      "<span><span class='audit-text-action-name'>Azure HA LB Handler</span></span>",
            "Update Nss Account Vsa List":              "<span><span class='audit-text-action-name'>Update NSS Provider Account list of working environments</span></span>",
            "External Kubernetes Clusters":             "<span><span class='audit-text-action-name'>Retrieve external clusters</span></span>",
            "Setup Ntp Server":                         "<span><span class='audit-text-action-name'>Setup Ntp Server</span></span>",
            "Migrate Cloud Manager To Service":         "<span><span class='audit-text-action-name'>Migrate Cloud Manager To Service</span></span>",
            "Update Current Service User":              "<span><span class='audit-text-action-name'>Update current Cloud Manager service user</span></span>",
            "Create Tenancy Account":                   "<span><span class='audit-text-action-name'>Create Tenancy Service Account</span></span>",
            "Manually Trigger Send Daily Notification": "<span><span class='audit-text-action-name'>Manually Trigger Send Daily Notification</span></span>",
            "Associate To Workspace":                   "<span><span class='audit-text-action-name'>Associate Service Connector To Workspace</span></span>"
            };
    });
})();
