(() => {
    'use strict';

    angular.module('noc').controller('AddOrEditKeyManagerController', ($scope, nocUI, nocHttp) => {
        $scope.saveAddKeyManager = () => {
            if (!$scope.addKeyManagerForm.$valid) {
                nocUI.handleFormValidity();
            } else {
                nocHttp.post({
                    url: '/occm/encryption/key-managers',
                    data: {
                        name: $scope.name,
                        address: $scope.address,
                        usernameField: $scope.usernameObject.usernameField || undefined,
                        usernameValue: $scope.usernameObject.usernameValue || undefined
                    }
                }, 'adding key manager', nocHttp.BLOCK)
                    .then($scope.closeDialog);
            }
        };

        $scope.saveEditKeyManager = () => {
            if (!$scope.addKeyManagerForm.$valid) {
                nocUI.handleFormValidity();
            } else {
                nocHttp.put({
                    url: '/occm/encryption/key-managers/' + $scope.publicId,
                    data: {
                        name: $scope.name,
                        address: $scope.address,
                        usernameField: $scope.usernameObject.usernameField || undefined,
                        usernameValue: $scope.usernameObject.usernameValue || undefined
                    }
                }, 'editing key manager', nocHttp.BLOCK)
                    .then($scope.closeDialog);
            }
        };

        $scope.usernameObject = {
            usernameField: $scope.usernameField,
            usernameValue: $scope.usernameValue
        };
    });
})();
