(function () {
    "use strict";

    angular.module("noc").controller("VolumeViewRoutingTablesDialogController", function ($scope, MetadataResource, nocHttp) {
        $scope.controllerData = { selectAll: false };

        $scope.onSelectionChange = function() {
            $scope.controllerData.selectAll = _.every($scope.routeTables, {selected: true});
        };

        $scope.onSelectAll = function() {
            _.forEach($scope.routeTables, function(row) {
                row.selected = $scope.controllerData.selectAll;
            });
        };

        $scope.expandRow = function (row) {
            row.expanded = !row.expanded;
            _.forEach($scope.routeTables, function(rowIter) {
                if (row !== rowIter) rowIter.expanded = false;
            });
        };

        $scope.validateRouteTables = function validateRouteTables() {
            return MetadataResource.validateFloatingIPAddresses(
                nocHttp,
                $scope.regionCode,
                $scope.vpcId,
                _($scope.routeTables).filter('selected').map('id').value(),
                {
                    clusterFloatingIP: $scope.floatingIps[2],
                    dataFloatingIP: $scope.floatingIps[0],
                    dataFloatingIP2: $scope.floatingIps[1],
                    svmFloatingIP: $scope.floatingIps[3]
                }
            );
        };

        $scope.modalOkIfValid = function modalOkIfValid() {
            $scope.userClickedNext = true;
            $scope.validateRouteTables()
                .then(function () {
                    $scope.$parent.modalOkIfValid('routingTablesForm');
                });
        };

        $scope.onSelectionChange();
    });
}());
