(function () {
    "use strict";

    angular.module("noc").controller("VolumeViewStorageSystemTagsController", function ($scope, nocHttp, volViewGeneralResource, $timeout, nocUI) {
        $scope.customTags = [];

        $scope.isValid = function () {
            return $scope.tagsForm.$valid;
        };

        $scope.updateTags = function () {
            if (!$scope.isValid()) {
                nocUI.handleFormValidity($scope.tagsForm, $scope);
                //ng-repeat adds $$hashKey id which interferes with object comparison
                //therefore using angular.copy to remove $$hashkey from objects
            } else if (_.isEqual($scope.originalTags, angular.copy($scope.customTags))) {
                $scope.noUpdateMessage = "No changes have been made.";
                $timeout(function () {
                    $scope.noUpdateMessage = null;
                }, 2000);
                $scope.tagsForm.$setPristine();

            } else {
                volViewGeneralResource.setAWSTags(nocHttp, $scope.customTags)
                    .then(function () {
                        $scope.originalTags = angular.copy($scope.customTags);
                        $scope.successMessage = "Your tags have been saved successfully.";
                            $timeout(function () {
                                $scope.successMessage = null;
                            }, 5000);
                        $scope.tagsForm.$setPristine();
                    });
            }
        };
    });
}());
