(() => {
    'use strict';
    angular.module('noc').controller('ChangeNetworkUtilizationController', ($scope, $state, nocHttp, workingEnvironmentResource, pidgeon) => {
        function initializeController() {
            $scope.isOptimized = _.find($scope.selectedWorkingEnvironment.ontapClusterProperties.broadcastDomainInfos, {'broadcastDomain': 'Default'}).mtu === 9000;
            $scope.optimizedNetworkUtilization = $scope.isOptimized ? 'optimized' : 'standard';
        }

        $scope.isDisabled = () => {
            return $scope.isOptimized === ($scope.optimizedNetworkUtilization === 'optimized');
        };

        $scope.changeOptimization = () => {
            workingEnvironmentResource.changeNetworkUtilization(nocHttp, $scope.selectedWorkingEnvironment, $scope.optimizedNetworkUtilization === 'optimized')
                .then(() => {
                    $scope.isOptimized = $scope.optimizedNetworkUtilization === 'optimized';
                    pidgeon.success('Network optimization level successfully changed.');
                    $scope.showMonitoring();
                });
        };

        $scope.updateSelectedWorkingEnvironment($state.params.workingEnvironmentId, ['ontapClusterProperties'])
            .then(initializeController)
            .catch($scope.backToGallery);
    });
})();
