(() => {
    'use strict';

    angular.module('noc').controller('CloneVolumeController', ($scope, nocHttp, nocUI, $stateParams, volumesResource) => {
        $scope.initialize = function () {
            $scope.$watch('volumes', function (volumes) {
                $scope.action = $scope.gadget === 'restoreVolume' ? 'Restore' : 'Clone';
                $scope.actionIng = $scope.gadget === 'restoreVolume' ? 'restoring' : 'cloning';
                /* istanbul ignore else */
                if (volumes) {
                    var volume = _.find($scope.volumes, {
                        name: $stateParams.selectedVolumeName || "",
                        svmName: $stateParams.selectedVolumeSVM || ""
                    });

                    //Do not re-initialize if nothing changed for the selected volume.
                    if (_.isEqual($scope.selectedVolume, volume)) return;
                    $scope.selectedVolume = volume;
                    if ($scope.selectedVolume) {
                        $scope.cloneVolumeRequest = {
                            newVolumeName: $scope.selectedVolume.name + '_' + _.toLower($scope.action)
                        };
                        $scope.getSnapshots();
                    }
                }
            });

            $scope.restore = {
                selectedSnapshot: ''
            };
        };

        $scope.cloneVolume = () => {
            if (!$scope.cloneVolumeForm.$valid) {
                nocUI.handleFormValidity($scope.cloneVolumeForm, $scope);
            } else {
                $scope.cloneVolumeRequest.parentSnapshot = _.get($scope.restore, 'selectedSnapshot.name');

                const volumeBaseUrl = $scope.selectedWorkingEnvironment._pathPrefix + 'volumes/' + $scope.selectedWorkingEnvironment.publicId + '/' + $scope.selectedVolume.svmName + '/' + $scope.selectedVolume.name;
                nocHttp.post({
                    url: volumeBaseUrl + "/clone",
                    data: $scope.cloneVolumeRequest
                }, $scope.actionIng + " volume", nocHttp.BLOCK)
                    .then(function () {
                        $scope.showMonitoring();
                    });
            }
        };

        $scope.getSnapshots = function getSnapshots() {
            volumesResource.getSnapshots(nocHttp, $scope.selectedWorkingEnvironment._pathPrefix, $scope.selectedWorkingEnvironment.publicId, $scope.selectedVolume.svmName, $scope.selectedVolume.name)
                .then((snapshots) => {
                    $scope.snapshots = snapshots;
                    $scope.latestSnapShot = _.get(snapshots, '[0]');

                    if ($scope.snapshots.length === 1) {
                        $scope.restore = {
                            selectedSnapshot: $scope.snapshots[0]
                        };
                    }
                });
        };

        $scope.initialize();
    });
})();
