(() => {
    'use strict';

    angular.module('noc').controller('CostController', function ($scope, workingEnvironmentResource, nocUI, $state, nocHttp, $q) {
        $scope.isLegacyCost = false;
        const costUnloading = nocUI.loading();

        $scope.initializeController = function initializeController() {
            $q.all([workingEnvironmentResource.getCost(nocHttp, $scope.selectedWorkingEnvironment),
                workingEnvironmentResource.getSavings(nocHttp, $scope.selectedWorkingEnvironment)])
                .then(_.spread((costResponse, savingsResponse) => {
                    $scope.costAndSavingsResponse = {
                        workingEnvironment: $scope.selectedWorkingEnvironment,
                        costResponse,
                        savingsResponse
                    };
                    costUnloading();
                }));
        };

        $scope.updateSelectedWorkingEnvironment($state.params.workingEnvironmentId)
            .then($scope.initializeController, $scope.backToGallery);
    });
})();
