(function() {
    "use strict";
    angular.module("noc").controller("SetVSAPasswordController", function($scope, workingEnvironmentResource, pidgeon, nocUI, nocPoller, nocHttp){
        $scope.changeVSAPassword = {};
        $scope.userName = _.get($scope.selectedWorkingEnvironment, 'ontapClusterProperties.userName') || 'admin';
        $scope.isValid = function(){
            return $scope.changeVSAPasswordForm.$valid;
        };

        $scope.saveVSAPassword = function(changePassword){
            if(!$scope.isValid()) {
                nocUI.handleFormValidity($scope.changeVSAPasswordForm, $scope);
            }else{
                nocPoller.pause();
                workingEnvironmentResource.setPassword(nocHttp, $scope.selectedWorkingEnvironment, changePassword.newPassword)
                    .then(function () {
                        pidgeon.success("Cloud Volumes ONTAP password successfully set.");
                        $scope.showMonitoring();
                    })
                    .finally(function () {
                        nocPoller.unpause();
                    });
            }
        };

        $scope.$on("$destroy", function(){
            nocUI.clearFormValidity();
        });
    });
})();