(() => {
    'use strict';

    angular.module('noc').controller('SnapshotVolumeController', ($scope, nocHttp, volumesResource, $stateParams, pidgeon, nocUI) => {
        $scope.initialize = () => {
            $scope.snapshotVolumeRequest = {
                snapshotVolumeName: 'manually.' + moment().format('YYYY-MM-DD_HHmm')
            };

            const stopWatch = $scope.$watch('volumes', (volumes) => {
                /* istanbul ignore else */
                if (volumes) {
                    $scope.selectedVolume = _.find($scope.volumes, {
                        name: $stateParams.selectedVolumeName || '',
                        svmName: $stateParams.selectedVolumeSVM || ''
                    });
                    stopWatch();
                }
            });
        };

        $scope.snapshotVolume = () => {
            if (!$scope.snapshotVolumeForm.$valid) {
                nocUI.handleFormValidity($scope.cloneVolumeForm, $scope);
            } else {
                volumesResource.postSnapshot(nocHttp, $scope.selectedWorkingEnvironment._pathPrefix, $scope.selectedWorkingEnvironment.publicId, $scope.selectedVolume.svmName, $scope.selectedVolume.name, $scope.snapshotVolumeRequest.snapshotVolumeName)
                    .then(() => {
                        pidgeon.success('Snapshot copy created successfully');
                        $scope.showMonitoring();
                    });
            }
        };

        $scope.initialize();
    });
})();
