(function () {
    "use strict";
    angular.module("noc").controller("WritingSpeedController", function ($scope, nocHttp, nocDialog,workingEnvironmentResource) {
        $scope.save = function () {
            if ($scope.model.writingSpeedState !== $scope.vsaResponse.cluster.writingSpeedState) {
                nocDialog.confirm(
                    "Confirm changing write speed to "+_.capitalize($scope.model.writingSpeedState),
                    "assets/templates/dialogs/change-writing-speed-confirm-content.html",
                    {width: 600}
                )
                    .then(function () {
                        var config = {
                            url: $scope.selectedWorkingEnvironment._pathPrefix + 'working-environments/' + $scope.selectedWorkingEnvironment.publicId + '/writing-speed',
                            data: {writingSpeedState: _.toUpper($scope.model.writingSpeedState)}
                        };

                        nocHttp.put(config, "changing write speed", nocHttp.BLOCK)
                            .then(function(){
                                workingEnvironmentResource.updateWorkingEnvironmentStatus($scope.selectedWorkingEnvironment, 'updating');
                            })
                            .finally(function () {
                                $scope.showMonitoring();
                            });
                    });
            } else {
                $scope.showMonitoring();
            }
        };

        $scope.$watch("vsaResponse.cluster.writingSpeedState", function(writingSpeedOriginalState) {
            $scope.model = {
                writingSpeedState : writingSpeedOriginalState,
                get confirmationNeeded() {
                    //checkbox needed only when changing from normal to high
                    return writingSpeedOriginalState === 'normal' && this.writingSpeedState === 'high';
                },
                highSpeedConfirmed : false
            };
        });
    });
})();