(function () {
    "use strict";

    angular.module("noc").controller("CloudOntapReviewController", function ($scope, BaseVirginStep, workingEnvironmentResource, nocUI, pidgeon, nocHttp) {
        BaseVirginStep.call($scope);

        $scope.mediatorToUpgradeVersion = function(workingEnvironment) {
            return workingEnvironment.isHA &&
            _.get(workingEnvironment.haProperties, 'mediatorVersionsToUpdate') && workingEnvironment.haProperties.mediatorVersionsToUpdate.length > 0 ? workingEnvironment.haProperties.mediatorVersionsToUpdate[0].mediatorVersion : null;
        };

        $scope.currentMediatorVersion = function(workingEnvironment) {
            return workingEnvironment.isHA &&
            workingEnvironment.haProperties ? workingEnvironment.haProperties.mediatorVersionInfo.version : null;
        };

        $scope.currentOntapVersion = function(workingEnvironment) {
            var version = "";
            if(_.endsWith(workingEnvironment.ontapClusterProperties.ontapVersion, '.ha')) {
                version =  'ONTAP-' + _.split(workingEnvironment.ontapClusterProperties.ontapVersion, '.ha', 2)[0];
            } else if(_.endsWith(workingEnvironment.ontapClusterProperties.ontapVersion, '.azure')) {
                version = 'ONTAP-' +  _.split(workingEnvironment.ontapClusterProperties.ontapVersion, '.azure', 2)[0];
            } else {
                version = 'ONTAP-' + workingEnvironment.ontapClusterProperties.ontapVersion;
            }

            if(_.includes(version,'.T')) {
                version =  _.split(version, '.T', 2)[0];
            }
            return version;
        };

        $scope.upgrade = function(workingEnvironment, version){
            if ($scope.isValid()) {
                workingEnvironmentResource.changeOntapImage(nocHttp, workingEnvironment, {updateType: "OCCM_PROVIDED", updateParameter: version.imageVersion})
                    .then(function(){
                        pidgeon.success("Working environment upgrade successfully triggered.");
                        $scope.wizardController.wizardCompletedSucssesfully = true;
                        $scope.exit();
                    });
            } else { //Not valid
                nocUI.handleErrorsInWizard(true);
            }
        };
    });
}());
