(function () {
    'use strict';

    angular.module('noc').controller('CloudSyncRegistrationCreateAccountStepController', function ($rootScope, $scope, nocHttp, BaseVirginStep,
                                                                                                   nocUI, nocCloudSyncService, usersResource,
                                                                                                   nocDialog) {
        $scope.initialize = function initialize() {
            BaseVirginStep.call($scope);
            $scope.company = $rootScope.about.siteIdentifier.company;
            $scope.password = {};

            usersResource.getUser(nocHttp, $scope.wizardController.userId)
                .then(function (userResponse) {
                    $scope.weUser = userResponse;
                    $scope.weUser.fullName = $scope.weUser.firstName + ' ' + $scope.weUser.lastName;
                });
        };

        $scope.signUp = function signUp() {
            if ($scope.isValid()) {
                nocCloudSyncService.signUp(nocHttp, $scope.wizardController.userId, {
                    email: $scope.weUser.email,
                    password: $scope.password.newPassword
                })
                    .then(function () {
                        $scope.wizardController.moveToCloudSyncActivationWizard();
                    });
            } else {
                nocUI.handleErrorsInWizard(true);
            }
        };

        /* istanbul ignore next: trivial */
        $scope.openEulaDialog = function openEulaDialog() {
            nocDialog.dialog('End User License Agreement', 'assets/templates/wizards/anterior-setup/eula-dialog.html', {width: 650});
        };

        $scope.initialize();
    });
}());
