(function() {
    "use strict";
    angular.module('noc').controller('CreateCIFSStepController', function($scope, $state, nocUI, nocNormalizerService) {
        nocUI.clearFormValidity();
        $scope.advanced = "Advanced";
        $scope.basic = "Basic";

        $scope.modes = { create : "create" };
        $scope.mode = $scope.modes.create;

        $scope.forms = {};
        $scope.state = $scope.basic;

        var defaultOUValue = "CN=Computers";

        var getNormalizedRequest = nocNormalizerService.getNormalizedCifsRequest;

        $scope.request = $scope.wizardController.failedRequestType && $scope.wizardController.failedRequest.cifsConfigurationRequest ?
            $scope.wizardController.failedRequest.cifsConfigurationRequest :
        {
            "dnsDomain": "",
            "activeDirectoryDomain": "",
            "ip1": "",
            "ip2": "",
            "netBIOS": $scope.wizardController.workingEnvironmentName.substring(0,15),
            "organizationalUnit": defaultOUValue,
            "activeDirectoryUsername": "administrator",
            "activeDirectoryPassword": ""
        };

        //Add IPs from failed request by parsing array
        if( $scope.wizardController.failedRequestType ) {
            $scope.request.ip1 =  _.get($scope.wizardController.failedRequest.cifsConfigurationRequest, 'ipAddresses[0]');
            $scope.request.ip2 = _.get($scope.wizardController.failedRequest.cifsConfigurationRequest, 'ipAddresses[1]');
        }

        var unbind = _.noop;
        var bind = function() {
            unbind = $scope.$watch('request.activeDirectoryDomain', function(activeDirectoryDomainValue) {
                $scope.request.dnsDomain = activeDirectoryDomainValue;
            });
        };

        $scope.switchToAdvanced = function() {
            $scope.state = $scope.advanced;
        };

        $scope.switchToBasic = function() {
            $scope.state = $scope.basic;
        };

        $scope.$watch('bindDnsAndAD.status', function(newValue) {
            if (newValue) {
                bind();
            } else {
                unbind();
            }
        });

        $scope.next = () => {
            nocUI.handleFormValidity();
            if ($scope.forms.cifsForm.$valid) {
                $scope.wizardController.cifsRequest = getNormalizedRequest($scope.request);
                nocUI.clearFormValidity();
                $state.go('.tiering-policy');
            } else {
                if (!$scope.forms.cifsForm[$scope.advanced].$valid) {
                    $scope.state = $scope.advanced;
                }
            }
        };

        $scope.$on('$destroy', function() {
            $scope.wizardController.backupStepData("cifs", {
                "request": $scope.request,
                "state": $scope.state,
                "bindDnsAndAD": $scope.bindDnsAndAD
            });
        });

        $scope.bindDnsAndAD = {status: true};
        _.assignIn($scope, $scope.getStepData("cifs"));

    });
})();