(() => {
    'use strict';

    angular.module('noc').controller('VirginCreateWorkingEnvironmentVPCStepController', ($scope, BaseCreateVpc, nocUI, pidgeon,
                                                                                         nocHttp, MetadataResource, $rootScope) => {
        BaseCreateVpc.call($scope, pidgeon, nocUI, nocHttp);

        $scope.next = function () {
            if ($rootScope.runningInChina) {
                $scope.wizardController.next('.byol');
                $scope.wizardController.encryptionType = 'NONE';
            } else if ($scope.wizardController.workingEnvironmentType === 'HA') {
                $scope.wizardController.next('.ha-public-key');
            } else {
                $scope.wizardController.next('.encryption');
            }
        };

        $scope.$on('$destroy', () => {
            $scope.wizardController.backupStepData('vpc', {
                vpcBeenHereBefore: $scope.wizardController.vpcBeenHereBefore,
                createVpcSelectObjects: {
                    access: _.get($scope.wizardController, 'createVpcSelectObjects.access'),
                    key: _.get($scope.wizardController, 'createVpcSelectObjects.key')
                }
            });

            $scope.wizardController.vpcBeenHereBefore = null;
            $scope.wizardController.createVpcSelectObjects = undefined;
        });

        $scope.getKeyPairs = function getKeyPairs() {
            if ($scope.keyData) {
                if ($scope.keyData[$scope.wizardController.createVpcSelectObjects.region.code].length === 0) {
                    const message = 'No key pairs are available in this region. Please add Key Pair or try another region.';

                    pidgeon.error(message, null, 'getKeyPairs');
                }
                $scope.wizardController.keyPairs = _.map($scope.keyData[$scope.wizardController.createVpcSelectObjects.region.code], (name) => {
                    return {name};
                });
                $scope.wizardController.createVpcSelectObjects.key = _.get($scope.wizardController, 'keyPairs[0]');
                if ($scope.wizardController.failedRequestType) $scope.recoverFailedRequestKey();
            } else {
                MetadataResource.getKeyPairs(nocHttp, pidgeon,
                    $scope.wizardController.createVpcSelectObjects.region.code,
                    true, $scope.wizardController.cloudProviderAccountId)
                    .then((keyPairs) => {
                        $scope.wizardController.keyPairs = _.map(keyPairs, (keyName) => {
                            return {name: keyName};
                        });
                        $scope.wizardController.createVpcSelectObjects.key = _.get($scope.wizardController, 'keyPairs[0]');
                        if ($scope.wizardController.failedRequestType) $scope.recoverFailedRequestKey();
                    });
            }
        };

        $scope.recoverFailedRequestKey = () => {
            if ($scope.wizardController.failedRequest.clusterKeyPairName) {
                $scope.wizardController.createVpcSelectObjects.key = _.find($scope.wizardController.keyPairs, {name: $scope.wizardController.failedRequest.clusterKeyPairName}) ||
                    $scope.wizardController.keyPairs[0];
                $scope.wizardController.createVpcSelectObjects.access = keyAccess;
            }
        };

        _.assignIn($scope.wizardController, $scope.wizardController.getStepData('vpc'));
        const keyAccess = {name: 'Key Pair', requestValue: 'key'};
        const defaultAccess = {name: 'Password', requestValue: 'password'};
        $scope.accesses = [defaultAccess, keyAccess];
        //Do not overwrite backed up data
        if (!$scope.wizardController.createVpcSelectObjects) _.set($scope.wizardController, 'createVpcSelectObjects.access', $scope.runningInIC ? keyAccess : defaultAccess);
        $scope.initialize();
    });
})();
