(() => {
    'use strict';

    angular.module('noc').controller('VirginCreateWorkingEnvironmentWormStepController', ($scope) => {
        $scope.initialize = () => {
            if ($scope.wizardController.failedRequestType) {
                const retentionPeriod = _.get($scope.wizardController.failedRequest, 'wormRequest.retentionPeriod');
                $scope.wizardController.worm = {
                    enabled: Boolean(retentionPeriod),
                    retentionPeriod: retentionPeriod
                };
            }

            /* istanbul ignore else */
            if (!$scope.wizardController.worm) {
                $scope.wizardController.worm = {enabled: false, retentionPeriod: {unit: 'years'}};
            }
        };

        $scope.retentionPeriodLimit = (unit) => {
            switch (unit) {
                case 'seconds':
                    return 65535;
                case 'minutes':
                    return 60;
                case 'hours':
                    return 24;
                case 'days':
                    return 10950;
                case 'months':
                    return 360;
                case 'years':
                    return 30;
                default:
                    return 30;
            }
        };

        $scope.clearRetentionPeriodDuration = () => {
            $scope.wizardController.worm.retentionPeriod.length = null;
        };

        $scope.initialize();
    });
})();
