(() => {
    'use strict';
    angular.module('noc').controller('EditAwsEncryptionKeysDialogController', ($scope, nocUI) => {
        $scope.initialize = () => {
            $scope.initializeData = {
                useKeysFromAnotherAccount: $scope.wizardController.useKeysFromAnotherAccount,
                awsEncryptionKey: _.cloneDeep($scope.wizardController.awsEncryptionKey)
            };
            $scope.expiringKeyExists = _.some($scope.wizardController.awsEncryptionKeys, ['expiring', true]);
            if (!$scope.wizardController.useKeysFromAnotherAccount) {
                $scope.updateSelection($scope.wizardController.awsEncryptionKey.keyId);
            }
        };

        $scope.updateSelection = (keyId) => {
            _.forEach($scope.wizardController.awsEncryptionKeys, (key) => {
                key.chosen = key.keyId === keyId;
            });
        };

        $scope.saveEditAwsEncryptionKeys = () => {
            if ($scope.isValid()) {
                if (!$scope.wizardController.useKeysFromAnotherAccount) {
                    $scope.wizardController.awsEncryptionKey = _.find($scope.wizardController.awsEncryptionKeys, {'chosen': true});
                }
                $scope.closeDialog();
                $scope.wizardController.encryptionType = 'AWS';
            } else {
                nocUI.handleFormValidity($scope.editAwsEncryptionKeys, $scope);
            }
        };

        $scope.cancelEditAwsEncryptionKeys = () => {
            $scope.wizardController.useKeysFromAnotherAccount = $scope.initializeData.useKeysFromAnotherAccount;
            $scope.wizardController.awsEncryptionKey = $scope.initializeData.awsEncryptionKey;
            $scope.closeDialog();
        };

        $scope.isValid = () => {
            return $scope.editAwsEncryptionKeys.$valid;
        };

        $scope.isOneSelected = () => {
            return _.some($scope.wizardController.awsEncryptionKeys, 'chosen');
        };

        $scope.initialize();
    });
})();
