(function () {
    'use strict';
    angular.module('noc').controller('SetupMediatorProxyController', function ($scope, nocUI) {
        $scope.proxyShowAuthenticationData = false;

        $scope.initialize = function () {
            if($scope.proxyValues.proxyPassword && $scope.proxyValues.proxyUserName) {
                $scope.proxyShowAuthenticationData = true;
            }
        };

        $scope.expandProxyAuthenticationData = function() {
            $scope.proxyShowAuthenticationData = !$scope.proxyShowAuthenticationData;
        };

        $scope.saveProxyMediatorSettings = function saveProxyMediatorSettings() {
            if ($scope.setupMediatorProxyForm.$valid) {
                $scope.wizardController.mediatorProxy.url = $scope.proxyValues.proxyUri;
                $scope.wizardController.mediatorProxy.userName = $scope.proxyValues.proxyUserName;
                $scope.wizardController.mediatorProxy.password = $scope.proxyValues.proxyPassword;
                $scope.closeDialog();
            } else {
                nocUI.handleFormValidity();
            }
        };

        $scope.cancelProxyMediatorSettings = function () {
            $scope.closeDialog();
        };

        $scope.initialize();
    });
})();