(() => {
    'use strict';

    angular.module('noc').controller('SnapMirrorLifsController', ($scope, BaseVirginStep, nocDialog, $state) => {
        BaseVirginStep.call($scope);

        $scope.initialize = () => {
            //$scope.lifsState is 'sourceLifs' or 'destinationLifs'.
            $scope.lifsState = $scope.wizardController.currentStateName;
            $scope.pathToThisStep = $scope.wizardController.currentStepPath;

            $scope.staticFeedback('assets/templates/wizards/virgin-snap-mirror/snapMirrorStaticFeedback.html');
            $scope.wizardController.selectedLifsAddresses[$scope.lifsState] = [];
            _.forEach($scope.lifs[$scope.lifsState], (lif) => {
                lif.selected = false;
            });
        };

        $scope.lifClicked = (lif) => {
            if (lif.selected) {
                //If scrolled up to here from advanced step AND un-selecting the last LIF, bring the wizard back to the current step, as it
                // should not be possible to do replication without LIFs:
                if ($scope.wizardController.currentStateName !== ($scope.lifsState) && $scope.wizardController.selectedLifsAddresses[$scope.lifsState].length === 1) {
                    $scope.wizardController.setWizardStep($scope.pathToThisStep);
                }
                _.pull($scope.wizardController.selectedLifsAddresses[$scope.lifsState], lif.address);
            } else {
                $scope.wizardController.selectedLifsAddresses[$scope.lifsState].push(lif.address);
            }
            lif.selected = !lif.selected;
        };

        $scope.next = () => {
            if (_.isEmpty($scope.wizardController.selectedLifsAddresses[$scope.lifsState])) {
                nocDialog.alert('You must select at least one LIF before you can proceed.');
            } else {
                $state.go($scope.wizardController.nextStep[$scope.lifsState]);
            }
        };

        $scope.initialize();
    });
})();
