(function () {
    'use strict';

    angular.module('noc').controller('SnapMirrorMaxTransferRateController', function ($scope, Constants) {
        $scope.initialize = function initialize() {
            $scope.wizardController.limitMaxTransferRate = true;
            $scope.maxInt32 = Constants.maxInt32;
            $scope.wizardController.maxTransferRateMBps = 100; //Arbitrary default value, Assaf decided.
            $scope.maxTransferRateChanged();
        };

        $scope.maxTransferRateChanged = function maxTransferRateChanged() {
          $scope.wizardController.maxTransferRate = $scope.wizardController.maxTransferRateMBps * 1024;
        };

        $scope.$on('$destroy', function () {
            $scope.wizardController.backupStepData('maxTransferRate', {
                limitMaxTransferRate: $scope.wizardController.limitMaxTransferRate,
                maxTransferRate: $scope.wizardController.maxTransferRate
            });
            $scope.wizardController.limitMaxTransferRate = undefined;
            $scope.wizardController.maxTransferRate = undefined;
        });
        _.assignIn($scope.wizardController, $scope.wizardController.getStepData('maxTransferRate'));

        $scope.initialize();
    });
}());
