(() => {
    'use strict';

    angular.module('noc').controller('SnapMirrorVolumesController', ($scope, nocHttp, $state, BaseVirginStep,
                                                                     volumesResource, nocUtil, $timeout) => {
        $scope.search = {term: ''};
        $scope.selectedSVM = {name: ''};
        $scope.filteredVolumes = [];
        $scope.volumesAreSelectable = true;
        $scope.capacityRadius = 50;
        $scope.capacityCircumference = 2 * Math.PI * $scope.capacityRadius;
        BaseVirginStep.call($scope);

        $scope.initialize = () => {
            $scope.staticFeedback('assets/templates/wizards/virgin-snap-mirror/snapMirrorStaticFeedback.html');
            $scope.wizardController.selectedVolume = null;

            volumesResource.getVolumes(nocHttp, $scope.wizardController.sourceWorkingEnvironment.publicId, $scope.wizardController.sourceWorkingEnvironment._pathPrefix)
                .then((volumes) => {
                    $scope.volumes = volumesResource.initVolumesForMonitoringDisplay($scope.wizardController.sourceWorkingEnvironment.cloudSyncProperties, volumes, $scope.wizardController.sourceWorkingEnvironment._cloudProviderName);
                    $scope.svms = _(volumes)
                        .map('svmName')
                        .union()
                        .map((svmName) => {
                            return {name: svmName, value: svmName};
                        })
                        .unshift({name: 'All SVMs', value: ''})
                        .value();

                    $scope.$watchGroup(['search.term', 'selectedSVM.name', 'volumes'], () => {
                        const filteredVolumesBySvm = $scope.selectedSVM.name ? _.filter($scope.volumes, {svmName: $scope.selectedSVM.name}) : $scope.volumes;

                        $scope.filteredVolumes = nocUtil.filterVolumes(filteredVolumesBySvm, $scope.search.term);
                    });
                });
        };

        $scope.volumeSelected = (volume) => {
            $scope.wizardController.selectedVolume = volume;
            $scope.wizardController.targetVolumeName = volume.name + '_copy';
            $scope.setWizardStep($scope.wizardController.path.volumes);
            $timeout($scope.next);
        };

        $scope.next = function next() {
            $scope.feedback('assets/templates/wizards/virgin-snap-mirror/volumes-feedback.html');
            $state.go('.destinationVolume');
        };

        $scope.initialize();
    });
})();
