(function () {
    "use strict";

    angular.module("noc").controller("VolumeViewCreateVolumeChooseController", function ($scope, nocDialog, $rootScope, volViewVolumesResource, nocFriendlyStore) {

        $scope.startWizard = function startWizard(volumeType) {
            $scope.wizardController.volumeType = volumeType;
            $scope.wizardController.isHa = volumeType === 'ha';
            $scope.wizardController.wizardTitle = 'Create ' + ($scope.wizardController.isHa ? 'HA' : '' ) + ' Volume';
            $rootScope.$broadcast("header-change-height");
            //reset haParams to prevent NOC-11215 Volume view - Re choosing regular volume keeps old form
            if ($scope.wizardController.volumeRequest) $scope.wizardController.volumeRequest.haParams = null;
            //reload disk types when changing volume type
            $scope.wizardController.diskTypes = volViewVolumesResource.getPossibleDiskTypes($scope.wizardController.isHa);
            if($scope.wizardController.isHa && !nocFriendlyStore.haVolume) {
                $scope.setWizardStep('volume-view.create-volume-wizard.choose.diagram');
            } else {
                $scope.setWizardStep('volume-view.create-volume-wizard.choose.details');
            }
        };

        $scope.openHaDiagramPopup = function openHaDiagramPopup() {
            nocDialog.confirm('', 'assets/templates/tabs/volume_view/dialogs/ha-structure-diagram.html', {
                width: 750,
                fromTop: "10%",
                isInDialog: true
            });
        };

    });
}());
