(function () {
    "use strict";
    angular.module('noc').filter('regionFormat', function (nocUtil, nocRegionsService) {
        return function (regionCode, html, regionMap) {
            var region = (regionMap ? regionMap[regionCode] : nocRegionsService.awsRegions()[regionCode]) || nocRegionsService.azureRegions()[regionCode] || { code: regionCode, name: regionCode, location: '', description: regionCode };
            if (html) {
                return nocUtil.formatSelect2(
                    region.name,
                    region.name,
                    region.location,
                    region.code);
            } else {
                var result = region.name;
                if (region.location) {
                    result += ' (' + region.location + ')';
                }
                return result;
            }
        };
    });

    angular.module("noc").filter('subnetIdFormat', function() {
        return function(array) {
            return _.uniq(array).join(', ');
        };
    });

    angular.module('noc').filter('availabilityZonesFormat', function () {
        var getRegion = function(regionZone) {
            var splitted = _.split(regionZone, '-');
            splitted.pop();
            return splitted.join('-');
        };

        var getZone = function(regionZone) {
            return _.split(regionZone, '-').pop();
        };

        return function (availabilityZones) {
            if (!availabilityZones || availabilityZones.length === 0) return "N/A";

            availabilityZones = _.uniq(availabilityZones).sort();
            availabilityZones = _.reduce(availabilityZones, function(acc, regionZone) {
                var currentRegion = getRegion(regionZone);
                if (currentRegion === acc.lastRegion) {
                    acc.array.push(getZone(regionZone));
                } else {
                    acc.lastRegion = currentRegion;
                    acc.array.push(regionZone);
                }
                return acc;
            }, {array: [], lastRegion: ""});

            return availabilityZones.array.join(", ");
        };
    });
})();