(function () {
    "use strict";

    
    angular.module('noc').filter('timelineFilter', function () {
        return function (auditGroup, filteredColumns) {
            var user = _.get(filteredColumns,"filteredUser.name");
            var allHumanUsers = user === "(All without system)";
            var filters = {
                actionName: _.get(filteredColumns,"filteredAction.name"),
                tenantName: _.get(filteredColumns,"filteredTenant.name"),
                workingEnvironmentName: _.get(filteredColumns,"filteredWe.name"),
                userName: allHumanUsers ? undefined : user};
            var status = _.get(filteredColumns, "filteredStatus.name");
            if(status) _.set(filters, status, true);
            _.forOwn(filters, function(value, key, filters){
                if( value === "(None)"){
                    filters[key] = null;
                }
            });
            filterUndefined(filters);
            return _.filter(allHumanUsers ? _.reject(auditGroup, {userName: "System"}) :auditGroup, filters);
        };
    });

    function filterUndefined(obj){
        for (var propName in obj) {
            if (obj[propName] === undefined) {
                delete obj[propName];
            }
        }
    }

})();

