(function(){
    "use strict";

    var messages = {};
    angular.module("noc").value('Messages', messages);

    messages.errors = {};

    messages.errors.invalid = "Fill in valid input.";
    messages.errors.required = "This field is required.";
    messages.errors["password-verify"] = "Passwords do not match.";
    messages.errors.email = "Enter a valid email address.";

    messages.errors.pattern = "Input does not match the required pattern.";
    messages.errors.number = "Enter a valid number.";
    messages.errors.wholeRange = _.template("Enter a whole number between {{from}} to {{to}}.");
    messages.errors.svmPassword = "Enter a password that is at least eight characters, contains at least one letter and one number, and does not contains the user name.";
    messages.errors.vlanRange = "Enter a range of no more than 150 numbers between 0-4096.";
    messages.errors.url = "Enter a valid URL.";
    messages.errors.passwordIsRequired = "Enter a password.";
    messages.errors.usernameIsRequired = "Enter a user name.";
    messages.errors.mutuallyRequired = "These optional fields are mutually required.";
    messages.errors.keyManagerUsernameValueEmail = messages.errors.email + " " + messages.errors.mutuallyRequired;
    messages.errors.tcpPort = "Enter a valid TCP port (1 to 65535).";
    messages.errors.maxTransferRateMBps = "Enter a number between 1 and 2,097,151.";
    messages.errors.positiveValueInRange = "Enter a positive value in the given range.";
    messages.errors.awsTagKeysMustBeUnique= "AWS tag keys must be unique.";
    messages.errors.azureTagKeysMustBeUnique = "Azure tag keys must be unique.";
    messages.errors.gcpLabelKeysMustBeUnique = "GCP label keys must be unique.";
    messages.errors["unique-volume-name-validation"] = "Volume name must be unique";
    messages.errors.awsTagKeysAreInvalid= "AWS tag keys may not be one of the following values: Tool, Type, InstanceId, Name, WorkingEnvironment, WorkingEnvironmentId, CloudONTAP.serial-number or CloudONTAP.encryption";
    messages.errors.floatingIPSShouldBeUnique= "Each of the floating IP addresses should be unique";
    messages.errors.nodeLicensesShouldBeDifferent= "Node 1 and 2 should use different platform serial numbers";
    messages.errors.nodeEvalLicensesShouldBeEqual = 'Evaluation serial number and platform serial number cannot be mixed';

    messages.defaultConfirm = "All your changes will be discarded. Continue?";
    messages.deleteConfirm = _.template("Are you sure you want to delete the {{type}}: {{name}}?");
    messages.deletePermanentConfirm = _.template("Are you sure you want to permanently delete the {{type}}: {{name}}?");
    messages.deleteAggregateConfirm = _.template("Are you sure you want to delete aggregate {{name}}?");
    messages.deleteTrustedCAConfirm = "Are you sure you want to delete the selected trusted CA certificate?";
    messages.removeConfirm = _.template("Are you sure you want to remove working environment {{name}}?");

    messages.noSnapshotsAlert = _.template("Volume '{{volume}}' has no Snapshots.");

    return messages;
}());
