(function () {
    "use strict";
    angular.module('noc').factory("actionRequiredResource", function (nocPoller, $rootScope) {
        var resource = {};

        resource.GLOBAL_ACTION_REQUIRED_GET_EVENT = "globalActionRequiredGetEvent";
        resource.GLOBAL_ACTION_REQUIRED_ERROR_EVENT = "globalActionRequiredErrorEvent";

        resource.startGlobalActionRequiredPolling = function (tenantOrWsId, onPollFn) {
            return nocPoller.start({
                    method: "GET",
                    url: "working-environments?tenantId=" + tenantOrWsId + "&fields=status,actionsRequired"
                },
                    5 * 60 * 1000,
                function (actionRequiredResponse) {
                    var actionsRequired = {};
                    _.forEach(actionRequiredResponse, function (workingEnvironments) {
                        _.forEach(workingEnvironments, function (we) {
                            actionsRequired[we.publicId] = we.actionsRequired;
                        });
                    });
                    $rootScope.$broadcast(resource.GLOBAL_ACTION_REQUIRED_GET_EVENT, actionsRequired);
                },
                function (error) {
                    $rootScope.$broadcast(resource.GLOBAL_ACTION_REQUIRED_ERROR_EVENT, error);
                }, onPollFn, true);
        };

        resource.ACTION_REQUIRED_GET_EVENT = "actionRequiredGetEvent";
        resource.ACTION_REQUIRED_ERROR_EVENT = "actionRequiredErrorEvent";

        resource.startActionRequiredPolling = function (workingEnvironment, onPollFn) {
            return nocPoller.start({
                    method: "GET",
                    url: workingEnvironment._pathPrefix + "working-environments/" + workingEnvironment.publicId + "?fields=actionsRequired"
                },
                    3 * 60 * 1000,
                function (workingEnvironmentResponse) {
                    $rootScope.$broadcast(resource.ACTION_REQUIRED_GET_EVENT, workingEnvironmentResponse.actionsRequired);
                },
                function (error) {
                    $rootScope.$broadcast(resource.ACTION_REQUIRED_ERROR_EVENT, error);
                }, onPollFn, true);
        };

        return resource;
    });
}());