(() => {
    'use strict';

    angular.module('noc').factory('PortalSetupResource', ($http) => {
        const resource = {};

        resource.savePortalProxyDetails = (proxy, nocHttp) => {
            if (nocHttp) {
                return nocHttp.post({
                    url: '/occm/setup-portal/proxy/setup',
                    data: proxy
                }, 'updating proxy', nocHttp.BLOCK);
            } else {
                return $http.post('/occm/setup-portal/proxy/setup', proxy);
            }
        };

        resource.completeConnectivityPendingSetup = () => {
            return $http.post('/occm/setup-portal/complete-connectivity-pending-setup')
                .then((response) => {
                    return response.data;
                });
        };

        resource.finish = (request) => {
            return $http.post('/occm/setup-portal/init', {
                adminUser: request.adminUser,
                company: request.company,
                site: request.site,
                tenancyAccountId: request.tenancyAccountId
            });
        };

        return resource;
    });
})();
