(() => {
    'use strict';

    angular.module('noc').factory('tenancyResource', ($injector) => {
        let _tenancyAccounts = {};
        let _loginToken;
        const resource = {};

        resource.setLoginToken = (loginToken) => {
            _loginToken = loginToken;
        };

        resource.reloadAccounts = () => {
            const $http = $injector.get('$http');

            return $http.get('/occm/tenancy-service/accounts')
                .then((tenancyAccounts) => {
                    _tenancyAccounts = tenancyAccounts.data;

                    _.forEach(_tenancyAccounts, (account) => {
                        account._accountDisplayName = account.accountName + ' | ' + account.accountPublicId;
                    });

                }).catch(() => {
                    return null;
                });
        };

        resource.getAccounts = () => {
            return _tenancyAccounts;
        };

        resource.createNewAccount = (accountName) => {
            const $http = $injector.get('$http');

            return $http.post('/occm/tenancy-service/accounts/account/' + accountName);
        };

        return resource;
    });
})();
