(function () {
    'use strict';

    angular.module('noc').config(function ($stateProvider, virginWizardTreeBuilder) {
        var wizardSteps = [
            {
                url: '/cloud-sync-activation-wizard?workingEnvironmentId&type&provider&userId&region&vpcId&subnetId&keyPairName',
                name: 'cloud-sync-activation-wizard',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: 'Integration with Cloud Sync'
                        };
                    },
                    exitOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            exit: function exit() {
                                this.checkAndSetState('main.working-environments.monitoring.sync-s3-status', {
                                    workingEnvironmentId: $stateParams.workingEnvironmentId,
                                    type: $stateParams.type,
                                    provider: $stateParams.provider
                                });
                            }
                        };
                    },
                    initOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            firstStep: 'cloud-sync-activation-wizard.layout.volumes',
                            hasInitStep: true,
                            workingEnvironmentId: $stateParams.workingEnvironmentId,
                            type: $stateParams.type,
                            provider: $stateParams.provider,
                            userId: $stateParams.userId,
                            region: $stateParams.region,
                            vpcId: $stateParams.vpcId,
                            subnetId: $stateParams.subnetId,
                            keyPairName: $stateParams.keyPairName
                        };
                    }
                }
            },
            {
                name: 'layout',
                abstract: true,
                controller: 'CloudSyncSupportController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-activation/support.html'
            },
            {
                name: 'volumes',
                controller: 'CloudSyncActivationVolumesStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-activation/volumes.html'
            },
            {
                name: 's3Bucket',
                controller: 'CloudSyncActivationS3BucketStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-activation/s3-bucket.html'
            },
            {
                name: 'dataBroker',
                controller: 'CloudSyncActivationDataBrokerStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-activation/data-broker.html'
            }
        ];

        var wizardTree = {
            'cloud-sync-activation-wizard': {
                layout: {
                    volumes: {
                        s3Bucket: {
                            dataBroker: true
                        }
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
}());
