(function () {
    'use strict';

    angular.module('noc').config(function ($stateProvider, virginWizardTreeBuilder) {
        var wizardSteps = [
            {
                url: '/cloud-sync-registration-wizard?workingEnvironmentId&type&provider&userId&region&vpcId&subnetId&keyPairName',
                name: 'cloud-sync-registration-wizard',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: 'Integration with Cloud Sync'
                        };
                    },
                    exitOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            exit: function exit() {
                                this.checkAndSetState('main.working-environments.monitoring.sync-s3-status', {
                                    workingEnvironmentId: $stateParams.workingEnvironmentId,
                                    type: $stateParams.type,
                                    provider: $stateParams.provider
                                });
                            },
                            moveToCloudSyncActivationWizard: function moveToCloudSyncActivationWizard() {
                                this.wizardCompletedSucssesfully = true;
                                this.checkAndSetState('cloud-sync-activation-wizard', {
                                    workingEnvironmentId: $stateParams.workingEnvironmentId,
                                    type: $stateParams.type,
                                    provider: $stateParams.provider,
                                    userId: $stateParams.userId,
                                    region: $stateParams.region,
                                    vpcId: $stateParams.vpcId,
                                    subnetId: $stateParams.subnetId,
                                    keyPairName: $stateParams.keyPairName
                                });
                            }
                        };
                    },
                    initOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            firstStep: 'cloud-sync-registration-wizard.layout.welcome',
                            hasInitStep: true,
                            userId: $stateParams.userId
                        };
                    }
                }
            },
            {
                name: 'layout',
                abstract: true,
                controller: 'CloudSyncSupportController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-activation/support.html'
            },
            {
                name: 'welcome',
                controller: 'CloudSyncRegistrationWelcomeStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-registration/welcome.html'
            },
            {
                name: 'createAccount',
                controller: 'CloudSyncRegistrationCreateAccountStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-registration/create-account.html'
            },
            {
                name: 'existingAccount',
                controller: 'CloudSyncRegistrationExistingAccountStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-sync-registration/existing-account.html'
            }
        ];

        var wizardTree = {
            'cloud-sync-registration-wizard': {
                layout: {
                    welcome: {
                        createAccount: true,
                        existingAccount: true
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
}());
