(() => {
    'use strict';

    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        const wizardSteps = [
            {
                url: '/cloud-ontap-upgrade?slTenantId&from&workingEnvironmentId&type&provider&first',
                name: 'cloud-ontap-upgrade',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: () => {
                        return {
                            title: 'Upgrade Wizard'
                        };
                    },
                    exitOptions: /*@ngInject*/($stateParams) => {
                        return {
                            exit: function exit() {
                                if ($stateParams.from) {
                                    this.checkAndSetState($stateParams.from, {
                                        workingEnvironmentId: $stateParams.workingEnvironmentId
                                    });
                                } else {
                                    this.checkAndSetState('main');
                                }
                            }
                        };
                    },
                    initOptions: () => {
                        return {
                            firstStep: 'cloud-ontap-upgrade.init'
                        };
                    }
                }
            },
            {
                name: 'init',
                controller: 'CloudOntapUpgradeInitController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/init.html'
            },
            {
                name: 'nss',
                controller: 'CloudOntapUpgradeNSSStepController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/nss.html'
            },
            {
                name: 'cifs',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/cifs-locks.html'
            },
            {
                name: 'version',
                controller: 'CloudOntapUpgradeVersionController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/version.html'
            },
            {
                name: 'eula',
                controller: 'CloudOntapUpgradeEulaController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/eula.html'
            },
            {
                name: 'review',
                controller: 'CloudOntapReviewController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/review.html'
            }
        ];

        const eulaEnding = {
            eula: {
                review: true
            }
        };

        const wizardTree = {
            'cloud-ontap-upgrade': {
                init: {
                    nss: {
                        cifs: {
                            version: eulaEnding
                        },
                        version: eulaEnding
                    },
                    cifs: {
                        version: eulaEnding
                    },
                    version: eulaEnding,
                    eula: {
                        review: true
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
})();
