(function () {
    'use strict';
    angular.module('noc').config(function ($stateProvider, virginWizardTreeBuilder) {

        var commonWizardSteps = [
            {
                name: 'setup-wizard',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: 'Setup Wizard'
                        };
                    },
                    exitOptions: function () {
                        return {exit: false};
                    },
                    initOptions: function () {
                        return {firstStep: 'setup-wizard.welcome'};
                    }
                }
            },
            {
                name: 'welcome',
                controller: 'SetupWizardWelcomeStepController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/welcome.html'
            },
            {
                name: 'review',
                controller: 'SetupWizardReviewController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/review.html'
            }
        ];

        var expertModeWizardSteps = [
            {
                name: 'restore-previous',
                controller: 'SetupWizardRestorePreviousController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/restore-previous.html'
            },
            {
                name: 'company',
                controller: 'SetupWizardSimpleController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/company.html'
            },
            {
                name: 'users',
                controller: 'SetupWizardSimpleController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/users.html'
            },
            {
                name: 'tenant',
                controller: 'SetupWizardSimpleController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/tenant.html'
            },
            {
                name: 'nss',
                controller: 'SetupWizardNssController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/nss.html'
            },
            {
                name: 'proxy',
                controller: 'SetupWizardProxyController',
                wizardTemplateUrl: 'assets/templates/wizards/setup/proxy.html'
            }
        ];

        var setupWizardSteps = commonWizardSteps.concat(expertModeWizardSteps);

        var setupWizardAfterCompany = {
            users: {
                tenant: {
                    nss: {
                        review: true
                    },
                    review: true
                }

            }
        };

        var setupWizardTree = {
            'setup-wizard': {
                welcome: {
                    'restore-previous': true,
                    company: setupWizardAfterCompany,
                    proxy: {
                        company: setupWizardAfterCompany
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, setupWizardTree, setupWizardSteps);
    });
}());