(() => {
    'use strict';

    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        var wizardSteps = [
            {
                url: "/snap-mirror-wizard?slTenantId&from&sourceId&targetId&sourceType&sourceProvider&targetType&targetProvider",
                name: "snap-mirror-wizard",
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: "Replication Setup"
                        };
                    },
                    exitOptions: /*@ngInject*/function($stateParams) {
                        return {
                            exit: function exit() {
                                if ($stateParams.from) {
                                    this.checkAndSetState($stateParams.from);
                                } else {
                                    this.checkAndSetState('main');
                                }
                            }
                        };
                    },
                    initOptions: function () {
                        return {
                            firstStep: "snap-mirror-wizard.init",
                            hasInitStep: true,
                            snapMirrorWizard: true
                        };
                    }
                }
            },
            {
                name: "init",
                controller: "SnapMirrorInitController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/init.html'
            },
            {
                name: "sourceLifs",
                controller: "SnapMirrorLifsController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/lifs.html'
            },
            {
                name: "destinationLifs",
                controller: "SnapMirrorLifsController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/lifs.html'
            },
            {
                name: "volumes",
                controller: "SnapMirrorVolumesController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/replication-volumes-step.html'
            },
            {
                name: "destinationVolume",
                controller: "SnapMirrorDestinationVolumeController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/replication-destination-volume-step.html'
            },
            {
                name: "maxTransferRate",
                controller: "SnapMirrorMaxTransferRateController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/replication-max-transfer-rate-step.html'
            },
            {
                name: "policies",
                controller: "SnapMirrorPolicyController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/policies.html'
            },
            {
                name: "schedules",
                controller: "SnapMirrorSchedulesController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/schedules.html'
            },
            {
                name: "review",
                controller: "SnapMirrorReviewController",
                wizardTemplateUrl: 'assets/templates/wizards/virgin-snap-mirror/review.html'
            }
        ];

        var volumesEnding = {
            destinationVolume: {
                maxTransferRate: {
                    policies: {
                        schedules: {
                            review: true
                        }
                    }
                }
            }
        };

        var wizardTree = {
            "snap-mirror-wizard": {
                init: {
                    sourceLifs: {
                        destinationLifs: {
                            volumes: volumesEnding
                        },
                        volumes: volumesEnding
                    },
                    destinationLifs: {
                        volumes: volumesEnding
                    },
                    volumes: volumesEnding
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
})();
