(function() {
    "use strict";
    angular.module('noc').factory('nocApprovalMessageBuilder',function(nocUtil, $sce) {
        var approveBuyDisk = "In order to complete your request please approve the following purchase:<ul style='margin-top:15px;'><li> {{numOfDisks}} {{diskType}} disk{{s}} of {{diskSize.size}} {{diskSize.unit}} {{perNode}}</li></ul>";
        var noPurchaseNeeded = "No new {{provider}} resources need to be purchased in order to complete this request.";

        this.buildTitle = function(data){
            var mainMessageVars = {
                provider: data.provider,
                s: data.numOfDisks > 1 ? 's' : '',
                numOfDisks: data.numOfDisks,
                diskSize: nocUtil.normalizeCapacity(data.diskSize),
                diskType: data.diskType,
                perNode : (data.isHA && data.provider === 'AWS') ? "per node" : ""
            };

            var titleTemplate = data.numOfDisks > 0 ? approveBuyDisk : noPurchaseNeeded;

            return $sce.trustAsHtml(_.template(titleTemplate)(mainMessageVars));
        };

        return this;
    });
})();