(() => {
    'use strict';
    angular.module('noc').service('cloudSyncGoThereService', (nocLocalStorage, nocDialog, $rootScope, nocUtil, nocCurrentUserService) => {
        const service = {};

        service.dontShowAgainInThisSession = false;

        service.dontShowAgain = function dontShowAgain() {
            nocLocalStorage.DONT_SHOW_CLOUD_SYNC_AD.save(true);
        };

        function retrieveWizardData(userId, workingEnvironment) {
            if (workingEnvironment.workingEnvironmentType !== 'ON_PREM') {
                const vsaInstance = nocUtil.getOccmInstanceAws(workingEnvironment);

                return {
                    workingEnvironmentId: workingEnvironment.publicId,
                    type: workingEnvironment._workingEnvironmentTypeByLocation,
                    provider: workingEnvironment._cloudProviderName,
                    userId,
                    region: workingEnvironment.awsProperties.regionName,
                    vpcId: workingEnvironment.awsProperties.vpc.vpcId,
                    subnetId: vsaInstance.subnetId,
                    keyPairName: vsaInstance.keyPairName
                };
            } else {
                return {
                    workingEnvironmentId: workingEnvironment.publicId,
                    type: workingEnvironment._workingEnvironmentTypeByLocation,
                    provider: workingEnvironment._cloudProviderName,
                    userId,
                    region: null,
                    vpcId: null,
                    subnetId: null,
                    keyPairName: null
                };
            }
        }

        service.launchCloudSyncWizard = function launchCloudSyncWizard(nocHttp, workingEnvironment) {
            $rootScope.checkAndSetState('cloud-sync-activation-wizard', retrieveWizardData(nocCurrentUserService.getCurrentUserPublicId(), workingEnvironment));
        };

        return service;
    });
})();
