(() => {
    'use strict';

    angular.module('noc').service('usersTableColumnsService', ($rootScope, uiGridConstants, nocCurrentUserService) => {
        const service = {};
        const gridMenuName = (_.get($rootScope.supportServices, 'portalService.usePortalAuthentication')) ? 'users-portal' : 'users-non-portal';
        const currentUserCellTemplate = "<div class='ui-grid-cell-contents'><i title='Current User' class='fa fa-user' ng-show='COL_FIELD'></i></div>";
        const titledCellTemplate = "<div class='ui-grid-cell-contents' title='{{COL_FIELD}}'><div class='trimmed-text'>{{COL_FIELD}}</div></div>";
        const currentUserRolePublicId = nocCurrentUserService.getCurrentUserRolePublicId();

        const defaultColumnsDef = [
            {displayName: '', visible: true, field: 'currentUser', width: 25, cellTemplate: currentUserCellTemplate, enableSorting: false},
            {displayName: 'Name', visible: true, field: 'name', minWidth: 170, cellTemplate: titledCellTemplate, sort: {direction: uiGridConstants.ASC, priority: 1}},
            {displayName: 'Email', visible: true, field: 'email', minWidth: 170},
            {displayName: 'Role', visible: true, field: 'role.name', minWidth: 170},
            {displayName: currentUserRolePublicId === 'Role-1' ? 'Tenant' : 'Working Environment', visible: true, field: '_association', minWidth: 170, cellTemplate: titledCellTemplate},
            {displayName: 'Authentication Type', visible: true, field: '_accountType', minWidth: 100},
            {displayName: '', visible: true, width: 55, field: 'state', cellTemplate: `<grid-menu grid-name=${gridMenuName}></grid-menu>`, enableSorting: false}
        ];

        _.forEach(defaultColumnsDef, (col) => {
            col.width = col.width || '*';
        });

        service.getColumnsDef = () => {
            return defaultColumnsDef;
        };

        return service;
    });
})();
