(function(){
    "use strict";

    angular.module("noc").service("nocNormalizerService", function () {
        var service = {};

        function listFromString(str, separator) {
            return _(str).split(separator).map(_.trim).compact().value();
        }

        service.normalizeUsersGroups = function(usersGroups) {
            return listFromString(usersGroups, ';');
        };

        service.normalizeCustomAccessControl = function(ips) {
            return listFromString(ips, ',');
        };

        service.getNormalizedCifsRequest = function (request) {
            var normalizedRequest = _.cloneDeep(request);

            normalizedRequest.ipAddresses = [request.ip1];
            if (request.ip2) normalizedRequest.ipAddresses.push(request.ip2);
            delete normalizedRequest.ip1;
            delete normalizedRequest.ip2;

            return normalizedRequest;
        };

        return service;
    });
}());