(function(){
    "use strict";

    angular.module("noc").factory("pidgeonFactory", function () {

        function Pidgeon(className, scope){
            this._className = className;
            this._scope = scope;
        }

        Pidgeon.prototype.serverErrorPrefix = "An error occurred while ";

        Pidgeon.prototype.error = function(prefix, errorResponse, callerType){
            if(this._dead) return;
            this._scope.pushError(prefix + (errorResponse ? (prefix ? ": " : "") + errorResponse.messageForDisplay() : ""), errorResponse ? errorResponse : {}, this._className, callerType);
        };

        Pidgeon.prototype.success = function (message) {
            if (this._dead) return;
            this._scope.pushSuccess(message);
        };

        Pidgeon.prototype.inProgress = function (message, seeTimeline, duration) {
            if (this._dead) return;
            this._scope.pushInProgress(message, seeTimeline, duration);
        };

        Pidgeon.prototype.clear = function(callerType){
            if(this._dead) return;
            this._scope.clearMessages(this._className ,callerType);
        };

        Pidgeon.prototype.kill = function(){
            if(this._dead) return; //You cannot kill what does not die
            this._dead = true;
            this._scope.clearMessages(this._className);
        };

        Pidgeon.prototype.DURATION_LONG = 1000 * 30;
        Pidgeon.prototype.DURATION_SHORT = 1000 * 6;

        return {spawn: function(className, scope){
            var pidgeon = new Pidgeon(className, scope);
            scope.$on("$destroy", function(){
                pidgeon.kill();
            });
            return pidgeon;
        }};
    });
}());