(function () {
    "use strict";

    angular.module("noc").factory("nocRegionsService", function ($http) {
        var _regions = {};

        function getRegionsFromServer() {
            return $http.get('/occm/system/cloud-provider-regions')
                .then(function (response) {
                    function regionsMap(regions) {
                        var obj = {};
                        _.forEach(regions, function (region) {
                            obj[region.code] = {'name': region.name, 'location': region.location, 'code': region.code};
                        });
                        return obj;
                    }

                    if (response.data['aws']) {
                        response.data.aws = regionsMap(response.data.aws);
                    }
                    if (response.data['azure']) {
                        response.data.azure = regionsMap(response.data.azure);
                    }
                    _regions.awsRegions = response.data.aws;
                    _regions.azureRegions = response.data.azure;
                });
        }

        function awsRegions() {
            return _regions.awsRegions;
        }

        function azureRegions() {
            return _regions.azureRegions;
        }

        return {
            azureRegions: azureRegions,
            awsRegions: awsRegions,
            getRegionsFromServer: getRegionsFromServer
        };
    });
}());