(function() {
    "use strict";
    angular.module('noc').service('occmUpdateService', function (nocLocalStorage, nocDialog, $rootScope) {

        var service = {};

        var dontShowAgainInThisSession = false;

        var isDismissedForever = function (update) {
            return nocLocalStorage.LATEST_UPDATE_IGNORED.restore() === update.name;
        };

        var off = _.noop;

        // updatesProperty - the propery on the rootScope where updates a kept.
        // isVolumeView - for design purposes only.
        service.showUpdatesDialog = function(updatesProperty, isVolumeView) {
            if (off !== _.noop) return; // dont watch twice
            off = $rootScope.$watch(updatesProperty, function(updates) {
                if (!_.isUndefined(updates)) {
                    showDialog(updates, isVolumeView);
                    off();
                }
            });
        };

        var showDialog = function(updates, isVolumeView) {
            if (_.isEmpty(updates) || isDismissedForever(updates[0]) || dontShowAgainInThisSession) return;

            return nocDialog.confirm('Software Update', 'assets/templates/dialogs/update-dialog.html', {update: updates[0], width: 650, isVolumeView: !!isVolumeView})
                .then(function () {
                    $rootScope.checkAndSetState('main.update');
                }).finally(function() {
                    dontShowAgainInThisSession = true;
                });
        };

        service.dontShowAgain = function(update) {
            nocLocalStorage.LATEST_UPDATE_IGNORED.save(update.name);
        };

        return service;
    });
})();
