(() => {
    'use strict';

    angular.module('noc').factory('nocWorkspacesService', ($http) => {
        const workspacesService = {};

        let _workspaces;

        workspacesService.getWorkspaces = () => {
            return _workspaces;
        };

        workspacesService.reloadWorkspaces = () => {
            return $http.get('/occm/tenancy-service/workspaces')
                .then((workspacesResponse) => {
                    _workspaces = workspacesResponse.data;

                    _.forEach(_workspaces, (workspace) => {
                        workspace._name = workspace.workspaceName;
                        workspace.key = workspace.workspacePublicId;
                    });
                });
        };

        return workspacesService;
    });
})();
