/**
 * Function magnifispec.fakeConfirmNew is mocking up promise mechanism, it is better to use real promises instead. *
 */
module.exports = (context) => {
    function isMagnifispecFunction(node) {
        return node.type === 'CallExpression' &&
            node.callee.type === 'MemberExpression' &&
            node.callee.object.name === 'magnifispec';
    }
    function isFakeConfirmNewCall(node) {
        return isMagnifispecFunction(node) &&
            node.callee.property.name === 'fakeConfirmNew';
    }
    function isMockDeferredPromiseCall(node) {
        return isMagnifispecFunction(node) &&
            node.callee.property.name === 'mockDeferredPromise';
    }

    return {
        CallExpression: (es) => {
            if (isFakeConfirmNewCall(es)) {
                context.report(es, 'fakeConfirmNew is deprecated, use mockConfirm instead. Don\'t forget to trigger the digest cycle.');
            } else if (isMockDeferredPromiseCall(es)) {
                context.report(es, 'mockDeferredPromise is deprecated, use spyOn(...).return(j.$q.when(...)\\.reject(...)) instead. Don\'t forget to trigger the digest cycle.');
            }
        }
    };
};
