const lazypipe = require('lazypipe');
const cheerio = require('gulp-cheerio');

const reporter = require('./reporter');

const nocValidationRule = require('./rules/noc-validation');
const nocIconRule = require('./rules/noc-icon');
const autoCompleteOffRule = require('./rules/auto-complete-off');
//See next comment
//const nocEqeqeq = require('./rules/noc-eqeqeq');

module.exports = lazypipe()
    .pipe(() => {
        return cheerio(($, file) => {
            nocValidationRule($, file, reporter);
            nocIconRule($, file, reporter);
            autoCompleteOffRule($, file, reporter);
            //This is HTML-lint rule that enforces no use of '==' or '!=' operators in HTML files.
            //Including it adds ~1.5 minutes to UI build so it is disabled by default, it makes sense to run it
            //once in a while to clean the code.
            //nocEqeqeq($, file, reporter);
        });
    });
