/*global require,module,process*/
var wiredep = require('wiredep');
var path = require('path');

// Karma configuration - see more info at http://karma-runner.github.io/0.10/config/configuration-file.html
module.exports = function (config) {
    config.set({
        browsers: ['Chrome'],

        //added for teamcity runs - browser is less responsive
        browserNoActivityTimeout:60000,

        frameworks: ['jasmine'],

        // list of files / patterns to load in the browser
        //eslint-disable-next-line lodash/prefer-lodash-method
        files: wiredep({devDependencies: true})['js'].map(function(file){
            return path.relative(process.cwd(), file);
        })
            .concat([

        /*******************,
         *  LIBS - karma should not watch them
         ******************/
            // images
            {pattern: 'app/images/**/*', watched: false, included: false},

            //our own extension to Jasmine
            'test/jasmine/magnifispec.js',
            'test/jasmine/boot.js',

        /*******************
         *  CODE
         ******************/
            //make sure that this one loads first
            'app/scripts/noc-main.js',

            //then load this one
            'app/scripts/constants.js',

            //patterns.js is created dynamically by Gulp, so we wan to load the processed file from dist
            'dist/assets/scripts/patterns.js',

            //load all the rest
            'app/scripts/**/*.js',

        /**************
         *    TEMPLATES
         ***************/

            'app/templates/**/*.html',

        /*******************
         *  TESTS
         ******************/
            'test/jasmine/spec/**/*.js'
        ]),

        /**************
         *    TEMPLATES
         ***************/

        exclude: [
            'app/scripts/non_json_response_rejector.js',
            'app/scripts/server_integrate.js',
            'app/scripts/main.js',
            '**/*routes_config.js'
        ],

        preprocessors :{
            'app/scripts/**/*.js': ['babel', 'coverage'],
            '**/*.html': 'ng-html2js',
            '**/spec/**/*.js': 'babel'
        },

        babelPreprocessor: {
            options: {
                presets: ['es2015'],
                sourceMap: 'inline'
            }
        },

        coverageReporter: {
            type: 'html',
            dir: 'test/coverage/',
            reporters:[
                { type: 'teamcity'},
                { type: 'html', subdir: '.'}
            ]
        },

        ngHtml2JsPreprocessor: {
            // strip this from the file path
            stripPrefix: 'app/',
            prependPrefix: 'assets/',

            // setting this option will create only a single module that contains templates
            // from all the files, so you can load them all with module('foo')
            moduleName: 'templates'
        },

        proxies: {
            '/assets/images': '/base/app/images'
        }

    });
};
