describe.skip('IfServiceSupported directive should', () => {
    let assertSuppoertedServices = (desc, supportServices, showElement) => {
        it(desc, inject(($rootScope,$compile,$log) => {
            jest.spyOn($log,'debug').mockImplementation(() => {});
            $rootScope.supportServices = supportServices;
            var element = $compile('<li noc-if-service-supported="someService"><button>Just Do It</button></li>')($rootScope.$new());

            expect(element.hasClass("service-not-supported")).toEqual(!showElement);
            if(showElement){
                expect($log.debug).not.toHaveBeenCalled();
            }else{
                //both service name and the menu item text should appear
                expect($log.debug.mock.calls[0][0]).toMatch(/^.*Just Do It.*someService.*$/);
            }
        }));
    };

    assertSuppoertedServices('show the element if the service is supported', {someServiceEnabled: true}, true);
    assertSuppoertedServices('hide the element if the service is not supported', {someServiceEnabled: false}, false);
    assertSuppoertedServices('hide the element if the service is not defined', undefined, false);

    it("should hide volume view if not allowed", inject(function($rootScope, $compile, $q, nocRoutingResolverService, $timeout) {
        jest.spyOn(nocRoutingResolverService, 'isVolumeViewAllowed').mockReturnValue($q.reject());
        $rootScope.supportServices = {volumeViewEnabled: true};

        var element = $compile('<li noc-if-service-supported="volumeView"><button>Just Do It</button></li>')($rootScope.$new());

        $timeout.flush();

        expect(element.hasClass("service-not-supported")).toEqual(true);
    }));
});