describe.skip('Match Header Height Directive', () => {
    'use strict';

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    const body = $('body');
    let scope;
    let element;
    let layoutHeader;
    let layoutHeaderHeight = '50';

    beforeEach(() => {
        scope = j.$rootScope.$new();
        scope.alertMessages = [];
        body.empty();
        body.append('<div class="main-header" style="height: 50px"></div>');
        body.append(j.$compile('<div class="layout"><div class="header"></div><div id="testedElement" style="height: 50px" noc-match-header-height></div></div>')(scope));
        layoutHeader = body.find('.layout .header');
        layoutHeader.css('height', layoutHeaderHeight);
        element = body.find('#testedElement');
        scope.$digest();
    });

    it('should match the header height upon an added alert', () => {
        element.css('height', '2px');
        expect(element.height()).not.toEqual(layoutHeaderHeight + mainHeaderHeight);
        scope.$apply(() => {
            scope.alertMessages = [];
        });
        j.$timeout.flush();
        layoutHeaderHeight = layoutHeader.height();
        const mainHeaderHeight = $('.main-header').height();
        expect(element.height()).toEqual(layoutHeaderHeight + mainHeaderHeight);
    });

    it('should match the header height upon a header-change-height event', () => {
        element.css('height', '2px');
        expect(element.height()).not.toEqual(layoutHeaderHeight + mainHeaderHeight);
        scope.$broadcast('header-change-height');
        j.$timeout.flush();
        layoutHeaderHeight = layoutHeader.height();
        const mainHeaderHeight = $('.main-header').height();
        expect(element.height()).toEqual(layoutHeaderHeight + mainHeaderHeight);
    });
});
