describe.skip("Permission spec", function () {
    "use strict";

    var nocAuthorizer;

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(inject(function (_nocAuthorizer_) {
        nocAuthorizer = _nocAuthorizer_;

        j.$rootScope.currentUser = {};
    }));

    it("should not add class no-permission if is not permitted (current user already set)", function () {
        jest.spyOn(nocAuthorizer, "isPermitted").mockReturnValue(true);
        var scope = j.$rootScope.$new();
        var element = j.$compile("<div noc-permission=\"'test-permission'\">")(scope);

        expect(scope.$$watchers.length).toEqual(1);
        expect(element.hasClass("no-permission")).toEqual(false);
    });

    it("should add class no-permission if is not permitted (current user already set)", function () {
        jest.spyOn(nocAuthorizer, "isPermitted").mockReturnValue(false);
        var element = j.$compile("<div noc-permission=\"'test-permission'\">")(j.$rootScope.$new());

        expect(element.hasClass("no-permission")).toEqual(true);
    });

    describe("Testing the watcher on user", function () {
        beforeEach(function () {
            j.$rootScope.currentUser = undefined;
        });

        it("should not add class no-permission if is permitted (current user set in future)", function () {
            jest.spyOn(nocAuthorizer, "isPermitted").mockReturnValue(true);
            var element = j.$compile("<div noc-permission=\"'test-permission'\">")(j.$rootScope.$new());

            expect(element.hasClass("no-permission")).toEqual(false);

            j.$rootScope.$apply(function(){
                j.$rootScope.currentUser = {};
            });

            expect(element.hasClass("no-permission")).toEqual(false);
        });

        it("should add class no-permission if is not permitted (current user set in future)", function () {
            jest.spyOn(nocAuthorizer, "isPermitted").mockReturnValue(false);
            var element = j.$compile("<div noc-permission=\"'test-permission'\">")(j.$rootScope.$new());

            expect(element.hasClass("no-permission")).toEqual(false);

            j.$rootScope.$apply(function(){
                j.$rootScope.currentUser = {};
            });

            expect(element.hasClass("no-permission")).toEqual(true);
        });

        it("should remove the watcher as soon as current user is set", function(){
            jest.spyOn(nocAuthorizer, "isPermitted").mockReturnValue(false);
            var scope = j.$rootScope.$new();
            j.$compile("<div noc-permission=\"'test-permission'\">")(scope);

            expect(j.$rootScope.$$watchers.length).toEqual(3);

            j.$rootScope.$apply(function(){
                j.$rootScope.currentUser = {};
            });

            expect(j.$rootScope.$$watchers.length).toEqual(1);
        });

    });
});