describe.skip("", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope, element;
    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.vlanRange = "100-200";
        element = j.$compile("<form name='changeRangeForm' id='range_form'>"+
                                    "<input ng-model='vlanRange' noc-range-verify='0-4096' noc-range-verify-size='150'/>"+
                                "</form>")(scope);
        scope.$digest();
    });

    it("should add 3 watchers on creation", function () {
        expect(scope.$$watchers.length).toEqual(3); //one for the RangeVerify error, and 1 for the ng-model
    });

    it("should set validity of RangeVerify to true if vlanRange is valid", function () {
        scope.vlanRange = "100-200";
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
        expect(element.children().hasClass("ng-valid-range-verify")).toEqual(true);
    });

    it("should set validity of RangeVerify to false if vlanRange is empty", function () {
        scope.vlanRange = "";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.children().hasClass("ng-invalid-range-verify")).toEqual(true);
    });

    it("should set validity of RangeVerify to false if left number is bigger than right number", function () {
        scope.vlanRange= "20-10";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.hasClass("ng-invalid-range-verify")).toEqual(true);
    });

    it("should set validity of RangeVerify to false if format of range is wrong", function () {
        scope.vlanRange= "20,10";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.hasClass("ng-invalid-range-verify")).toEqual(true);
    });

    it("should set validity of RangeVerify to false if range is bigger than noc-range-verify-size values", function () {
        scope.vlanRange= "0-200";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.hasClass("ng-invalid-range-verify")).toEqual(true);
    });

    it("should set validity of RangeVerify to false if one of the numbers is out of the allowed range", function () {
        scope.vlanRange= "4000-4097";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.hasClass("ng-invalid-range-verify")).toEqual(true);
    });

});