describe.skip("noc unique directive spec", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope, formElement, firstForm;

    var isValid = function(element) {
        return (element.hasClass('ng-valid-unique'));
    };

    var isInvalid = function(element) {
        return (element.hasClass('ng-invalid-unique'));
    };

    var input1, input2, input3;

    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.model1 = "";
        scope.model2 = "";
        formElement = j.$compile("<ng-form name='changePasswordForm' id='password_form'>"+
            "<ng-form name='inner1'>" +
            "<div><input name='1' type='text' ng-model='model1' noc-unique/></div>"+
            "<div><input name='2' type='text' ng-model='model2' noc-unique/></div>"+
            "<div><input name='3' type='text' ng-model='model3' noc-unique/></div>"+
            "</ng-form>" +
            "<ng-form name='inner2'>" +
            "<div><input type='text' ng-model='modelb1' noc-unique/></div>"+
            "<div><input type='text' ng-model='modelb2' noc-unique/></div>"+
            "</ng-form></ng-form>")(scope);
        scope.$digest();
        firstForm = formElement.children().first("ng-form");
        input1 = firstForm.find("[name=1]");
        input2 = firstForm.find("[name=2]");
        input3 = firstForm.find("[name=3]");
    });

    describe("single group scenario", function () {
        it("should set validity to true if the first input is empty", function () {
            scope.model1= "";
            scope.model2= "bla";
            scope.$digest();

            expect(isValid(firstForm)).toEqual(true);
            expect(isValid(firstForm.children().children())).toEqual(true);
        });

        it("should set validity to true if the second input is empty", function () {
            scope.model1= "bla";
            scope.model2= "";
            scope.$digest();

            expect(isValid(firstForm)).toEqual(true);
            expect(isValid(firstForm.children().children())).toEqual(true);
        });

        it("should set validity of different to false if inputs are the same", function () {
            scope.model1 = "bla";
            scope.model2 = "bla";
            scope.$digest();

            expect(firstForm.hasClass("ng-invalid")).toEqual(true);
            expect(firstForm.hasClass("ng-invalid-unique")).toEqual(true);
        });

        it("should set invalid check to false if inputs begin with 'Eval-'", function () {
            scope.model1 = "Eval-12345";
            scope.model2 = "Eval-12345";
            scope.$digest();

            expect(firstForm.hasClass("ng-invalid")).toEqual(false);
            expect(firstForm.hasClass("ng-invalid-unique")).toEqual(false);
        });

        it("should set validity of different to true if inputs are the different", function () {
            scope.model1 = "bla";
            scope.model2 = "bla";
            scope.$digest();

            scope.model2 = "bla2";
            scope.$digest();

            expect(isInvalid(firstForm)).toEqual(false);
            expect(isValid(firstForm)).toEqual(true);
            expect(isInvalid(firstForm)).toEqual(false);
            expect(isValid(firstForm)).toEqual(true);

            expect(firstForm.children().children().hasClass("ng-valid-unique")).toEqual(true);
        });

        it("should always invalidate the changed input", function () {
            scope.model1 = "bla";

            scope.$digest();

            scope.model2 = "bla";

            scope.$digest();

            expect(isValid(input1)).toEqual(true);
            expect(isInvalid(input2)).toEqual(true);
            expect(isValid(input3)).toEqual(true);

            scope.model3 = "bla";

            scope.$digest();

            expect(isValid(input1)).toEqual(true);
            expect(isInvalid(input2)).toEqual(true);
            expect(isInvalid(input3)).toEqual(true);
            expect(firstForm.hasClass("ng-invalid")).toEqual(true);

            scope.model1 = "blue";
            scope.model2 = "bla";
            scope.model3 = "bla";

            scope.$digest();

            expect(isValid(input1)).toEqual(true);
            expect(isInvalid(input2)).toEqual(true);
            expect(isInvalid(input3)).toEqual(true);
            expect(firstForm.hasClass("ng-invalid")).toEqual(true);
        });
    });

    describe("mutliple groups scenario", function () {
        it("two groups does not relate", function () {
            scope.model1 = "bla";
            scope.modelb1 = "bla";
            scope.$digest();

            expect(isValid(formElement)).toEqual(true);
            expect(formElement.hasClass("ng-valid")).toEqual(true);

            scope.modelb2 = "bla";
            scope.$digest();

            expect(isInvalid(formElement)).toEqual(true);
            expect(formElement.hasClass("ng-invalid")).toEqual(true);
        });
    });
});