describe.skip('noc virtual scroll', () => {
    'use strict';

    const j = magnifispec.setup(),
        elementTemplate = '<div style="height: 10px; width:10px">{{data}}</div>',
        templateUrl = '/template.html',
        body = $('body');
    let collection,
        scope, tElement,
        directivesScope;

    beforeEach(() => {
        body.empty();
        collection = _.range(1, 1001);
        scope = j.$rootScope.$new();
        scope.collection = collection;
        scope.text = 'someText';
        tElement = $('<div noc-virtual-scroll="collection" noc-vs-repeater-template="' + templateUrl + '" style="height: 100px;" noc-vs-repeater-name="data"/>');
        j.$httpBackend.expectGET(j.nocBaseUrl + templateUrl).respond(elementTemplate);

        tElement = j.$compile(tElement)(scope);
        body.append(tElement);

        directivesScope = tElement.scope();

        jest.spyOn(directivesScope, 'render');
        jest.spyOn(directivesScope, 'calcDimensions');

        j.$httpBackend.flush();
        j.$timeout.flush();
        scope.$digest();
    });

    it('should at least list some elements', () => {
        //Each element takes a row, 10 elements + 2 buffer rows = 12
        expect($('.noc-vs-content').children().length).toEqual(12);
    });

    it('should stretch the canvas to virtually hold all elements', () => {
        expect($('.noc-virtual-scroll').height()).toEqual(1000 * 10);
        scope.$apply(() => {
            scope.collection = _.slice(scope.collection, 5);
        });
        expect(directivesScope.render).toHaveBeenCalledWith();
        expect($('.noc-virtual-scroll').height()).toEqual((1000 - 5) * 10);
    });

    it('should set initialized after initialization, render and calcDimensions', () => {
        expect(tElement.scope().initialized).toEqual(true);
        expect(directivesScope.render).toHaveBeenCalledWith();
        expect(directivesScope.calcDimensions).toHaveBeenCalledWith();
    });
});
