describe('noc at list one selected directive spec', function () {
    'use strict';

    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });
    var scope, formElement, firstForm;

    var isValid = function (element) {
        return (element.hasClass('ng-valid-at-least-one'));
    };

    var isInvalid = function (element) {
        return (element.hasClass('ng-invalid-at-least-one'));
    };

    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.model1 = true;
        scope.model2 = false;
        formElement = j.$compile('<ng-form name=\'changePasswordForm\' id=\'password_form\'>' +
            '<ng-form name=\'inner1\'>' +
            '<div><input name=\'1\' type=\'checkbox\' ng-model=\'model1\' noc-at-least-one-selected/></div>' +
            '<div><input name=\'2\' type=\'checkbox\' ng-model=\'model2\' noc-at-least-one-selected/></div>' +
            '<div><input name=\'3\' type=\'checkbox\' ng-model=\'model3\' noc-at-least-one-selected/></div>' +
            '<div><input name=\'4\' type=\'checkbox\' ng-model=\'model4\' noc-at-least-one-selected/></div>' +
            '</ng-form>' +
            '<ng-form name=\'inner2\'>' +
            '<div><input type=\'checkbox\' ng-model=\'modelb1\'/></div>' +
            '<div><input type=\'checkbox\' ng-model=\'modelb2\'/></div>' +
            '</ng-form></ng-form>')(scope);
        scope.$digest();
        firstForm = formElement.children().first('ng-form');
    });

    describe('at list one selected', function () {
        it('should set validity to true if one of the inputs is non falsy', function () {
            scope.model1 = false;
            scope.model3 = false;
            scope.model2 = false;
            scope.model4 = true;
            scope.$digest();

            expect(isValid(firstForm)).toEqual(true);
        });

        it('should set validity to false if none of the inputs is truethy', function () {
            scope.model1 = false;
            scope.model2 = false;
            scope.model3 = false;
            scope.$digest();

            expect(isInvalid(firstForm)).toEqual(true);
        });

        it('should change from valid to invalid', function () {
            scope.model1 = false;
            scope.model2 = false;
            scope.model3 = false;
            scope.model4 = false;
            scope.$digest();

            expect(isInvalid(firstForm)).toEqual(true);

            scope.model4 = true;
            scope.$digest();

            expect(isValid(firstForm)).toEqual(true);

        });
    });
});