describe('Lodash auto filter', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope;

    const compile = (html) => {
        var element = j.$compile(html)(scope);
        scope.$digest();

        return element.contents().text();
    };

    beforeEach(() => {
        scope =  j.$rootScope.$new();
    });

    it('capitalizes a string', () => {
        scope.name = 'bEck';

        expect(
            compile(    '<span>{{name | __capitalize}}</span>'))
            .toEqual(   'Beck');
    });

    it('supports passing parameters to a lodash function', () => {
        scope.name = 'beck';

        expect(
            compile(    '<span>{{name | __repeat:3}}</span>'))
            .toEqual(   'beckbeckbeck');
    });

    it('supports filters for arrays and uses functions as parameters', () => {
        scope.mySquare = (x) => x * x;

        expect(
            compile(    '<div><span ng-repeat="number in [3,2,1] | __sortBy | __map:mySquare">{{number}}</span></div>'))
            .toEqual(   '149');
    });
});