describe('Timeline filter', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    let theFilter;
    const summaries = magnifispec.auditSummaries;

    beforeEach(() => {
        theFilter = j.$filter('timelineFilter');
    });

    it('should filter summaries correctly with filter', () => {
        const filteredColumns = {filteredAction: {name: 'Delete Vsa Working Environment'}};
        const expectedFilteredSummaries = [{
            actionName: 'Delete Vsa Working Environment',
            status: 'Success',
            userName: 'admin admin',
            tenantName: 'Tenant 1',
            workingEnvironmentName: 'ss',
            containsFailedRecords: true
        }];
        expect(theFilter(summaries, filteredColumns)).toEqual(expectedFilteredSummaries);
    });

    it('should not filter summaries correctly with no filter', () => {
        expect(theFilter(summaries, {})).toEqual(summaries);
    });
});
