describe("StorageSystemViewSelectionController", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        magnifispec.mockStandaloneController("StorageSystemViewSelectionController", {});
    });

    describe("Initialization", function () {
        it("should select the current view", function () {
            expect(j.scope.selectedView).toEqual('storage-system-view');
        });
    });

    describe("switchToVolumeView", function () {
        beforeEach(function () {
            j.scope.checkAndSetState = jest.fn();
        });
        it("should set localStorage correctly", function () {
            jest.spyOn(j.nocLocalStorage.VOLUME_VIEW, "save").mockImplementation(() => {});
            j.scope.switchToVolumeView();
            expect(j.nocLocalStorage.VOLUME_VIEW.save).toHaveBeenCalledWith(true);
        });
        it("should switch the view", function () {
            j.scope.switchToVolumeView();
            expect(j.scope.checkAndSetState).toHaveBeenCalledWith('volume-view.volumes');
        });
    });
});