describe('AuditController', () => {
    'use strict';

    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    beforeEach(() => {
        magnifispec.mockConfirmController('AuditController', {}, {});
    });

    describe('createColumnLists', () => {
        it('should create the correct column lists when calling createColumnLists', () => {
            j.scope.summaries = magnifispec.auditSummaries;
            j.scope.filterSummaries();

            j.scope.createColumnLists(j.scope.summaries);

            const expectedColumnLists = {
                tenantList: [{name: '(None)'}, {name: 'Tenant 1'}],
                actionList: [{name: 'Change Current User Azure Credentials'}, {name: 'Change Keys'}, {name: 'Delete Vsa Working Environment'}, {name: 'Login'}, {name: 'Update Cloud Ontap Metadata'}],
                weList: [{name: '(None)'}, {name: 'ss'}],
                userList: [{name: 'admin admin'}, {name: 'System'}],
                statusList: [{name: 'Failed'}, {name: 'Success'}],
                enableSearch: {tenant: false, action: true, we: false, user: false}
            };
            expect(j.scope.columnLists).toEqual(expectedColumnLists);
        });

        it('should create empty column lists when calling createColumnLists with no summaries', () => {
            j.scope.summaries = [];
            j.scope.filterSummaries();

            j.scope.createColumnLists(j.scope.summaries);

            const expectedColumnLists = {
                tenantList: [],
                actionList: [],
                weList: [],
                userList: [],
                statusList: [],
                enableSearch: {tenant: false, action: false, we: false, user: false}
            };
            expect(j.scope.columnLists).toEqual(expectedColumnLists);
        });
    });
});
