describe('Audit Template Finder', () => {
    'use strict';
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    angular.module('noc').service('AuditTemplates-Kuki', () => {
        return {'kuki': 'pukiold'};
    });

    let auditTemplateFinder;

    beforeEach(inject((_auditTemplateFinder_, _AuditTemplatesLatest_) => {
        _AuditTemplatesLatest_['kuki'] = 'puki';
        auditTemplateFinder = _auditTemplateFinder_;
    }));

    it('should use the latest template if no version matches', () => {
        expect(auditTemplateFinder.find('kuki', 'I do not exist')).toEqual('puki');
    });

    it('should use the specific version if the specific version matches', () => {
        expect(auditTemplateFinder.find('kuki', 'Kuki')).toEqual('pukiold');
    });

    it('should return missingActionName if no actionName is passed in', () => {
        expect(auditTemplateFinder.find(null, null).indexOf('Action name is not defined')).toBeGreaterThan(1);
    });

    it('should return templateNotFound if no matching template was found for actionName', () => {
        expect(auditTemplateFinder.find('I do not exist', null).indexOf('No Template defined for action')).toBeGreaterThan(1);
    });
});
