describe("StopVSAController", function () {
    "use strict";
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        magnifispec.mockTabsController("StopVSAController", {}, {
            selectedWorkingEnvironment : {_pathPrefix:"/vsa/",publicId:1},
            showMonitoring: jest.fn(),
            updateWorkingEnvironmentStatus: jest.fn()
        });
    });

    describe("stopVSA", function () {
        beforeEach(function () {
            jest.spyOn(j.workingEnvironmentResource, "stopVsa");
            jest.spyOn(j.workingEnvironmentResource, "updateWorkingEnvironmentStatus").mockImplementation(() => {});
            j.scope.svmEditingOptions = {takeSnapshots: false};
        });

        it("should set starting stopping state to stopping and handle success case upon success", function () {
            j.$httpBackend.expectPOST(j.nocBaseUrl + "/vsa/working-environments/1/stop?takeSnapshots=false").respond(200);
            j.scope.stopVSA();
            j.$httpBackend.flush();
            expect(j.workingEnvironmentResource.updateWorkingEnvironmentStatus).toHaveBeenCalledWith(j.scope.selectedWorkingEnvironment, "stopping");
            expect(j.nocUI.block).toHaveBeenCalled();
            expect(j.workingEnvironmentResource.stopVsa).toHaveBeenCalledWith(jasmine.any(Object), j.scope.selectedWorkingEnvironment, j.scope.svmEditingOptions.takeSnapshots);
            expect(j.scope.gadget).toBeUndefined();
            expect(j.scope.showMonitoring).toHaveBeenCalled();
            expect(j.nocUI.unblock).toHaveBeenCalled();
            
        });

        it("should set starting stopping state to stopping and handle error case upon error", function () {
            j.$httpBackend.expectPOST(j.nocBaseUrl + "/vsa/working-environments/1/stop?takeSnapshots=false").respond(400, j.errorResponse);
            j.scope.stopVSA();
            j.$httpBackend.flush();

            expect(j.scope.updateWorkingEnvironmentStatus).not.toHaveBeenCalled();
            expect(j.nocUI.block).toHaveBeenCalled();
            expect(j.workingEnvironmentResource.stopVsa).toHaveBeenCalledWith(jasmine.any(Object), j.scope.selectedWorkingEnvironment, j.scope.svmEditingOptions.takeSnapshots);
            expect(j.pidgeon.error).toHaveBeenCalled();
            expect(j.nocUI.unblock).toHaveBeenCalled();

        });

        it("should change the api according the WE type", function () {
            j.scope.selectedWorkingEnvironment._pathPrefix = '/aws/ha/';
            j.$httpBackend.expectPOST(j.nocBaseUrl + "/aws/ha/working-environments/1/stop?takeSnapshots=false").respond(400, j.errorResponse);
            j.scope.stopVSA();
            j.$httpBackend.flush();

            expect(j.scope.updateWorkingEnvironmentStatus).not.toHaveBeenCalled();
            expect(j.nocUI.block).toHaveBeenCalled();
            expect(j.workingEnvironmentResource.stopVsa).toHaveBeenCalledWith(jasmine.any(Object), j.scope.selectedWorkingEnvironment, j.scope.svmEditingOptions.takeSnapshots);
            expect(j.pidgeon.error).toHaveBeenCalled();
            expect(j.nocUI.unblock).toHaveBeenCalled();
        });
    });
});