describe('Cost Annual Component', () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    let controller;
    const mockAnnualData = [{'start': '2017-12-01', 'end': '2018-01-01', 'estimated': false, 'total': {'amount': 182.336, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 6.335999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 6.335999999999999, 'currency': 'USD'}, 'usage': {'amount': 352.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 105.60000000000001, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 105.60000000000001, 'currency': 'USD'}, 'usage': {'amount': 352.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 70.4, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 70.4, 'currency': 'USD'}, 'usage': {'amount': 352.0, 'units': 'Hrs'}}]}]}, {'start': '2018-01-01', 'end': '2018-02-01', 'estimated': false, 'total': {'amount': 220.668, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 7.667999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 7.667999999999999, 'currency': 'USD'}, 'usage': {'amount': 426.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 127.80000000000001, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 127.80000000000001, 'currency': 'USD'}, 'usage': {'amount': 426.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 85.2, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 85.2, 'currency': 'USD'}, 'usage': {'amount': 426.0, 'units': 'Hrs'}}]}]}, {'start': '2018-02-01', 'end': '2018-03-01', 'estimated': false, 'total': {'amount': 48.692, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 1.692, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 1.692, 'currency': 'USD'}, 'usage': {'amount': 94.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 28.200000000000003, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 28.200000000000003, 'currency': 'USD'}, 'usage': {'amount': 94.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 18.8, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 18.8, 'currency': 'USD'}, 'usage': {'amount': 94.0, 'units': 'Hrs'}}]}]}, {'start': '2018-03-01', 'end': '2018-04-01', 'estimated': false, 'total': {'amount': 274.54, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 9.54, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 9.54, 'currency': 'USD'}, 'usage': {'amount': 530.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 159.0, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 159.0, 'currency': 'USD'}, 'usage': {'amount': 530.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 106.0, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 106.0, 'currency': 'USD'}, 'usage': {'amount': 530.0, 'units': 'Hrs'}}]}]}, {'start': '2018-04-01', 'end': '2018-05-01', 'estimated': false, 'total': {'amount': 144.522, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 5.021999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 5.021999999999999, 'currency': 'USD'}, 'usage': {'amount': 279.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 83.7, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 83.7, 'currency': 'USD'}, 'usage': {'amount': 279.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 55.800000000000004, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 55.800000000000004, 'currency': 'USD'}, 'usage': {'amount': 279.0, 'units': 'Hrs'}}]}]}, {'start': '2018-05-01', 'end': '2018-06-01', 'estimated': false, 'total': {'amount': 21.238000000000003, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 0.738, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 0.738, 'currency': 'USD'}, 'usage': {'amount': 41.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 12.3, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 12.3, 'currency': 'USD'}, 'usage': {'amount': 41.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 8.200000000000001, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 8.200000000000001, 'currency': 'USD'}, 'usage': {'amount': 41.0, 'units': 'Hrs'}}]}]}, {'start': '2018-06-01', 'end': '2018-07-01', 'estimated': false, 'total': {'amount': 296.296, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 10.296, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 10.296, 'currency': 'USD'}, 'usage': {'amount': 572.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 171.60000000000002, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 171.60000000000002, 'currency': 'USD'}, 'usage': {'amount': 572.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 114.4, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 114.4, 'currency': 'USD'}, 'usage': {'amount': 572.0, 'units': 'Hrs'}}]}]}, {'start': '2018-07-01', 'end': '2018-08-01', 'estimated': false, 'total': {'amount': 76.146, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 2.646, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 2.646, 'currency': 'USD'}, 'usage': {'amount': 147.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 44.1, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 44.1, 'currency': 'USD'}, 'usage': {'amount': 147.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 29.400000000000002, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 29.400000000000002, 'currency': 'USD'}, 'usage': {'amount': 147.0, 'units': 'Hrs'}}]}]}, {'start': '2018-08-01', 'end': '2018-09-01', 'estimated': false, 'total': {'amount': 180.782, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 6.281999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 6.281999999999999, 'currency': 'USD'}, 'usage': {'amount': 349.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 104.69999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 104.69999999999999, 'currency': 'USD'}, 'usage': {'amount': 349.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 69.8, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 69.8, 'currency': 'USD'}, 'usage': {'amount': 349.0, 'units': 'Hrs'}}]}]}, {'start': '2018-09-01', 'end': '2018-10-01', 'estimated': false, 'total': {'amount': 168.868, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 5.867999999999999, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 5.867999999999999, 'currency': 'USD'}, 'usage': {'amount': 326.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 97.80000000000001, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 97.80000000000001, 'currency': 'USD'}, 'usage': {'amount': 326.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 65.2, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 65.2, 'currency': 'USD'}, 'usage': {'amount': 326.0, 'units': 'Hrs'}}]}]}, {'start': '2018-10-01', 'end': '2018-11-01', 'estimated': false, 'total': {'amount': 9.324, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 0.32399999999999995, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 0.32399999999999995, 'currency': 'USD'}, 'usage': {'amount': 18.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 5.4, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 5.4, 'currency': 'USD'}, 'usage': {'amount': 18.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 3.6, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 3.6, 'currency': 'USD'}, 'usage': {'amount': 18.0, 'units': 'Hrs'}}]}]}, {'start': '2018-11-01', 'end': '2018-12-01', 'estimated': false, 'total': {'amount': 175.08400000000003, 'currency': 'USD'}, 'costByService': [{'name': 'DataTransfer', 'total': {'amount': 6.084, 'currency': 'USD'}, 'costByUsage': [{'name': 'EC2-out', 'cost': {'amount': 6.084, 'currency': 'USD'}, 'usage': {'amount': 338.0, 'units': 'GB'}}]}, {'name': 'EBS', 'total': {'amount': 101.4, 'currency': 'USD'}, 'costByUsage': [{'name': 'gp2', 'cost': {'amount': 101.4, 'currency': 'USD'}, 'usage': {'amount': 338.0, 'units': 'GB-Month'}}]}, {'name': 'EC2', 'total': {'amount': 67.60000000000001, 'currency': 'USD'}, 'costByUsage': [{'name': 'm4.xlarge', 'cost': {'amount': 67.60000000000001, 'currency': 'USD'}, 'usage': {'amount': 338.0, 'units': 'Hrs'}}]}]}];
    const constructedAnnualBarDataRes = {'totalCosts': [{'y': 182}, {'y': 221}, {'y': 49}, {'y': 275}, {'y': 145}, {'y': 21}, {'y': 296}, {'y': 76}, {'y': 181}, {'y': 169}, {'y': 9}, {'y': 175}],
        'categories': [
            moment({year: '2017', month: 11}), moment({year: '2018', month: 0}), moment({year: '2018', month: 1}), moment({year: '2018', month: 2}),
            moment({year: '2018', month: 3}), moment({year: '2018', month: 4}), moment({year: '2018', month: 5}), moment({year: '2018', month: 6}),
            moment({year: '2018', month: 7}), moment({year: '2018', month: 8}), moment({year: '2018', month: 9}), moment({year: '2018', month: 10})
        ]
    };

    beforeEach(inject(($componentController) => {
        controller = $componentController('costAnnualComponent', null, {
            annualData: mockAnnualData
        });
    }));

    it('should call init functions', () => {
        jest.spyOn(controller, 'costAnnualBarHighchart').mockImplementation(() => {});
        jest.spyOn(controller, 'constructAnnualBarData').mockImplementation(() => {});

        controller.$onInit();
        expect(controller.constructAnnualBarData).toHaveBeenCalled();
        expect(controller.costAnnualBarHighchart).toHaveBeenCalled();
    });

    it('should construct bar chart datum properly', () =>
        expect(controller.constructAnnualBarData(mockAnnualData))
            .toEqual(constructedAnnualBarDataRes)
    );
});
