describe("Tenants Gallery Controller", function(){
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        magnifispec.mockTabsController("TenantsGalleryController", {}, {setTenants: jest.fn()});

        j.extendedTenantsUrl = j.nocBaseUrl + "/tenants?fields=workingEnvironmentsInformation";
        j.tenantsUrl = j.nocBaseUrl + "/tenants";
        j.$rootScope.checkAndSetState = jest.fn();
    });
    var mockedTenants = [
        {   publicId: "1",
            name: "Paris",
            descrition: "This is paris",
            costCenter: "1234"},
        {   publicId: "2",
            name: "TLV",
            descrition: "This is Tel-Aviv",
            costCenter: "2345"},
        {   publicId: "3",
            name: "Lapid",
            descrition: "This is my home",
            costCenter: "3456"}
    ];
    describe("Initialize Tenants", function () {
        it("should remove the current tenant from the list, fill the working environments, the role, and the tenant if there is tenant id, and no tenant if there is no tenant id", function () {
            j.$httpBackend.expectGET(j.extendedTenantsUrl).respond(200, mockedTenants);
            j.$httpBackend.flush();
            expect(j.nocUI.loading.mock.calls.length).toEqual(1);
            expect(j.nocUI.unloading.mock.calls.length).toEqual(1);
            expect(j.scope.setTenants).toHaveBeenCalledWith(mockedTenants);
            expect(j.pidgeon.clear).toHaveBeenCalledWith("retrieving list of tenants");
        });

        it("should push an alert in case of failing to load tenants from the server", function () {
            j.$httpBackend.expectGET(j.extendedTenantsUrl).respond(400, j.errorResponse);
            j.$httpBackend.flush();
            expect(j.nocUI.loading.mock.calls.length).toEqual(1);
            expect(j.nocUI.unloading.mock.calls.length).toEqual(1);
            expect(j.pidgeon.error).toHaveBeenCalled();
        });
    });
});