describe('Replication status tab Controller', function () {
    'use strict';

    let j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    let stopper, _nocSelectedWorkspaceOrTenantService;

    beforeEach(inject((nocSelectedWorkspaceOrTenantService) => {
        stopper = jest.fn();
        jest.spyOn(j.replicationResource, 'startReplicationStatusAllPolling').mockReturnValue(stopper);
        magnifispec.mockTabsController('ReplicationStatusTabController', {}, {
            selectedTenant: {publicId: 1},
            updateTable: jest.fn()
        });
        j.$rootScope.backToGallery = jest.fn();

        _nocSelectedWorkspaceOrTenantService = nocSelectedWorkspaceOrTenantService;
        jest.spyOn(_nocSelectedWorkspaceOrTenantService, 'getPublicId').mockReturnValue(1);
    }));

    describe('initializeController', function () {
        it('should start polling', function () {
            j.scope.initializeController();
            j.$timeout.flush();
            expect(j.replicationResource.startReplicationStatusAllPolling).toHaveBeenCalledWith(1);
        });
    });

    describe('destroy', function () {
        it('should stop polling', function () {
            j.$timeout.flush();
            j.$rootScope.$broadcast('$destroy');
            expect(stopper).toHaveBeenCalled();
        });
    });
});