describe("nocSetWizardStep", function () {
    "use strict";
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope;
    var htmlElement;
    beforeEach(function () {
        scope =  j.$rootScope.$new();
        scope.value = "";
        scope.text = "initial text";
        scope.currentStepPath = "this.step";
        scope.setWizardStep = jest.fn();
        htmlElement = $("<input type='text'  ng-model='value'  text='{{text}}' noc-set-wizard-step='{model:\"value\", step:\"go.to.that.step\"}'/>");
    });

    it("should set the right step when the current step is different than the requested and the model has changed", function () {
        j.$compile(htmlElement)(scope);
        scope.$apply(function() {
            scope.value = "new value";
        });
        expect(scope.setWizardStep).toHaveBeenCalledWith("go.to.that.step");
    });

    it("should do nothing if the model doesn't change", function () {
        j.$compile(htmlElement)(scope);
        expect(scope.setWizardStep).not.toHaveBeenCalled();
    });

    it("should do nothing if the current path is like the requested path", function () {
        j.$compile(htmlElement)(scope);
        scope.currentStepPath = "go.to.that.step";
        expect(scope.setWizardStep).not.toHaveBeenCalled();
    });
});
