describe('SnapMirrorMaxTransferRateController', () => {
    'use strict';

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    beforeEach(() => {
        magnifispec.mockWizardStepController('SnapMirrorMaxTransferRateController', {}, {});
    });

    describe('initialize', () => {
        it('should initialize stuff', () => {
            expect(j.scope.wizardController.limitMaxTransferRate).toEqual(true);
            expect(j.scope.maxInt32).toEqual(Math.pow(2, 31) - 1);
            expect(j.scope.wizardController.maxTransferRateMBps).toEqual(100);
            expect(j.scope.wizardController.maxTransferRate).toEqual(102400);
        });
    });

    describe('maxTransferRateChanged', () => {
        it('should update maxTransferRate based on maxTransferRateMBps', () => {
            j.scope.wizardController.maxTransferRateMBps = 3;

            j.scope.maxTransferRateChanged();

            expect(j.scope.wizardController.maxTransferRate).toEqual(3 * 1024);
        });
    });

    describe('backing up data', function () {
        it('should backup data and clear fields upon destroy', function () {
            j.scope.wizardController.limitMaxTransferRate = true;
            j.scope.wizardController.maxTransferRate = 1234;
            j.$rootScope.$broadcast('$destroy');
            expect(j.parentScope.backupStepData).toHaveBeenCalledWith('maxTransferRate', {
                limitMaxTransferRate: true,
                maxTransferRate: 1234
            });
            expect(j.scope.wizardController.limitMaxTransferRate).not.toBeDefined();
            expect(j.scope.wizardController.maxTransferRate).not.toBeDefined();
        });

        it('should restore backed up data upon creation ', function () {
            expect(j.parentScope.getStepData).toHaveBeenCalledWith('maxTransferRate');
        });
    });
});
