describe("Schedules Step Controller", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    var response = [
        {"name": "5min", "description": "@:00,:05,:10,:15,:20,:25,:30,:35,:40,:45,:50,:55", "cronJobSchedule": {"months": [], "days": [], "weekDays": [], "hours": [], "minutes": [0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55]}},
        {"name": "8hour", "description": "@2:15,10:15,18:15", "cronJobSchedule": {"months": [], "days": [], "weekDays": [], "hours": [2, 10, 18], "minutes": [15]}},
        {"name": "daily", "description": "@0:10", "cronJobSchedule": {"months": [], "days": [], "weekDays": [], "hours": [0], "minutes": [10]}},
        {"name": "hourly", "description": "@:05", "cronJobSchedule": {"months": [], "days": [], "weekDays": [], "hours": [], "minutes": [5]}},
        {"name": "weekly", "description": "Sun@0:15", "cronJobSchedule": {"months": [], "days": [], "weekDays": [0], "hours": [0], "minutes": [15]}},
        {"name": "weird", "description": "description", "cronJobSchedule": {"months": [0, 3, 6], "days": [], "weekDays": [0, 5, 6], "hours": [0], "minutes": [22]}},
        {"name": "monthly", "description": "description", "cronJobSchedule": {"months": [], "days": [0], "weekDays": [], "hours": [15], "minutes": [31]}},
        {"name": "Example 1", "description": "In January only, every hour at @:05", "cronJobSchedule": {"months": [0], "days": [], "weekDays": [], "hours": [], "minutes": [5]}}
    ];

    var nocSchedulesService, constants;
    beforeEach(inject(function (_nocSchedulesService_, Constants) {
        nocSchedulesService = _nocSchedulesService_;
        constants = Constants;
        j.$httpBackend.expectGET(j.nocBaseUrl + "/replication/schedules/value2").respond(200, response);
        magnifispec.mockWizardStepController("SnapMirrorSchedulesController", {}, {targetWorkingEnvironment: {name: "value1", publicId: "value2"}});
    }));

    describe("initialize", function () {
        it("should work upon success", function () {
            jest.spyOn(nocSchedulesService, "stringifyCron").mockReturnValue(["Array", "of", "Strings"]);
            j.$httpBackend.flush();

            expect(j.scope.schedules.length).toEqual(response.length);
            expect(_.every(j.scope.schedules, 'descArr')).toEqual(true);
            expect(j.nocUI.unloading).toHaveBeenCalled();

        });

        it("should define one-time-schedule", function () {
            var oneTimeCopy = {name: constants.emptyReplicationScheduleDescription, description: "No schedule"};
            expect(j.scope.oneTimeSchedule).toEqual(oneTimeCopy);
        });
    });

    it("should cleanup after itself on $destory", function () {
        j.scope.wizardController.selectedSchedule = "Every night";
        j.$rootScope.$broadcast('$destroy');
        expect(j.scope.wizardController.selectedSchedule).toBe(null);
    });
});