describe('VirginCreateWorkingEnvironmentWritingSpeedStepController', () => {
    'use strict';

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    beforeEach(() => {
        magnifispec.mockWizardStepController('VirginCreateWorkingEnvironmentWritingSpeedStepController', {}, {});
    });

    describe('init', () => {
        it('should set writing speed to normal if not set yet', () => {
            j.scope.init();

            expect(j.scope.wizardController.writingSpeedState).toEqual('NORMAL');
        });

        it('should set not override existing writing speed', () => {
            j.scope.wizardController.writingSpeedState = 'HIGH';

            j.scope.init();

            expect(j.scope.wizardController.writingSpeedState).not.toEqual('normal');
        });

        it('should restore data from failover request', () => {
            j.scope.wizardController.failedRequestType = true;
            j.scope.wizardController.failedRequest = {writingSpeedState: 'HIGH'};

            j.scope.init();

            expect(j.scope.wizardController.writingSpeedState).toEqual('HIGH');
            expect(j.scope.wizardController.highSpeedConfirmed).toEqual(true);
        });
    });
});
