(() => {
    'use strict';

    angular.module('noc').service('ransomwareProtectionResource', () => {
        const service = {};

        service.getEligibleVolumes = (volumes) => {
            return _.filter(volumes, (vol) => {
                return vol.state === 'online' && vol.volumeType === 'rw' && !vol.rootVolume && !vol.moving;
            });
        };

        service.countVolumesNoSnapshot = (volumes) => {
            return (_.filter(volumes, ({snapshotPolicy: 'none'})).length);
        };

        return service;
    });
})();
